/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 34 "parser.y"


#define PARSER_VERSION_STRING "parser_version_3"

#include "config.h"
#include <stdlib.h>
#include <termios.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <setjmp.h>
#include <sys/stat.h>                    /* structure stat       */
#include <unistd.h>                      /* prototype for stat() */
#include <sys/wait.h>
#include <signal.h>
#include <stdarg.h>
#include <pwd.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#ifdef __linux__
#include <mntent.h>
#endif

#include "dosemu_config.h"
#include "emu.h"
#ifdef X86_EMULATOR
#include "cpu-emu.h"
#endif
#include "disks.h"
#include "port.h"
#define allow_io	port_allow_io
#include "lpt.h"
#include "video.h"
#include "vc.h"
#include "mouse.h"
#include "serial.h"
#include "timers.h"
#include "keymaps.h"
#include "keyb_server.h"
#include "memory.h"
#include "mapping.h"
#include "utilities.h"
#include "aspi.h"
#include "pktdrvr.h"
#include "iodev.h" /* for TM_BIOS / TM_PIT / TM_LINUX */

#define USERVAR_PREF	"dosemu_"
static int user_scope_level;

static int after_secure_check = 0;
static serial_t *sptr;
static serial_t nullser;
static mouse_t *mptr = &config.mouse;
static int c_ser = 0;

static struct disk *dptr;
static struct disk nulldisk;
static int c_hdisks = 0;
static int c_fdisks = 0;

int dexe_running = 0;
static int dexe_forbid_disk = 1;
char own_hostname[128];

static struct printer nullptr;
static struct printer *pptr = &nullptr;
static int c_printers = 0;

static int ports_permission = IO_RDWR;
static unsigned int ports_ormask = 0;
static unsigned int ports_andmask = 0xFFFF;
static unsigned int portspeed = 0;
static char dev_name[255]= "";

static int errors = 0;
static int warnings = 0;

static int priv_lvl = 0;
static int saved_priv_lvl = 0; 


static char *file_being_parsed;

			/* this to ensure we are parsing a new style */
static int parser_version_3_style_used = 0;
#define CONFNAME_V3USED "version_3_style_used"

	/* local procedures */

static void start_ports(void);
static void start_mouse(void);
static void stop_mouse(void);
static void start_debug(void);
static void start_video(void);
static void stop_video(void);
static void set_vesamodes(int width, int height, int color_bits);
static int detect_vbios_seg(void);
static int detect_vbios_size(void);
static void stop_ttylocks(void);
static void start_serial(void);
static void stop_serial(void);
static void start_printer(void);
static void stop_printer(void);
static void start_keyboard(void);
static void keytable_start(int layout);
static void keytable_stop(void);
static void dump_keytables_to_file(char *name);
static void stop_terminal(void);
static void start_disk(void);
static void do_part(char *);
static void start_bootdisk(void);
static void start_floppy(void);
static void stop_disk(int token);
static void start_vnet(char *);
static FILE* open_file(char* filename);
static void close_file(FILE* file);
static void write_to_syslog(char *message);
static void set_irq_value(int bits, int i1);
static void set_irq_range(int bits, int i1, int i2);
static int undefine_config_variable(char *name);
static void check_user_var(char *name);
static char *run_shell(char *command);
static int for_each_handling(int loopid, char *varname, char *delim, char *list);
static void enter_user_scope(int incstackptr);
static void leave_user_scope(int incstackptr);
static void handle_features(int which, int value);
static void set_joy_device(char *devstring);
static int parse_timemode(const char *);

	/* class stuff */
#define IFCLASS(m) if (is_in_allowed_classes(m))

#define CL_ALL			-1
#define CL_VAR		    0x200
#define CL_VPORT	   0x2000
#define CL_PORT		  0x20000
#define CL_PCI		  0x40000
#define CL_IRQ		 0x200000
#define CL_HARDRAM	0x1000000
#define CL_NET		0x2000000

static int is_in_allowed_classes(int mask);

#define TOF(x) ( x.type == TYPE_REAL ? x.value.r : x.value.i )
#define V_VAL(x,y,z) \
do { x.type = y.type; if (x.type == TYPE_REAL) x.value.r = (z); \
      else x.value.i = (z); } \
while (0)

	/* variables in lexer.l */




	/* for unicode keyboard plugin */
static void keyb_mod(int wich, t_keysym keynum, int unicode);
static void dump_keytable_part(FILE *f, t_keysym *map, int size);



#include "translate.h"
#include "dosemu_charset.h"
	/* for translate plugin */

static void set_internal_charset(char *charset_name);
static void set_external_charset(char *charset_name);



/* Line 268 of yacc.c  */
#line 244 "parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INTEGER = 258,
     L_OFF = 259,
     L_ON = 260,
     L_AUTO = 261,
     L_YES = 262,
     L_NO = 263,
     CHIPSET_TYPE = 264,
     KEYB_LAYOUT = 265,
     REAL = 266,
     STRING = 267,
     VARIABLE = 268,
     EXPRTEST = 269,
     INTCAST = 270,
     REALCAST = 271,
     SHL_OP = 272,
     SHR_OP = 273,
     XOR_OP = 274,
     OR_OP = 275,
     AND_OP = 276,
     NOT_OP = 277,
     NEQ_OP = 278,
     LE_OP = 279,
     GE_OP = 280,
     EQ_OP = 281,
     STR_NEQ_OP = 282,
     STR_EQ_OP = 283,
     L_OR_OP = 284,
     L_AND_OP = 285,
     BIT_NOT_OP = 286,
     UPLUS = 287,
     UMINUS = 288,
     STRLEN = 289,
     STRTOL = 290,
     STRNCMP = 291,
     STRCAT = 292,
     STRPBRK = 293,
     STRSPLIT = 294,
     STRCHR = 295,
     STRRCHR = 296,
     STRSTR = 297,
     STRDEL = 298,
     STRSPN = 299,
     STRCSPN = 300,
     SHELL = 301,
     DEFINED = 302,
     DEFINE = 303,
     UNDEF = 304,
     IFSTATEMENT = 305,
     WHILESTATEMENT = 306,
     FOREACHSTATEMENT = 307,
     ENTER_USER_SPACE = 308,
     LEAVE_USER_SPACE = 309,
     CHECKUSERVAR = 310,
     DOSBANNER = 311,
     FASTFLOPPY = 312,
     HOGTHRESH = 313,
     SPEAKER = 314,
     IPXSUPPORT = 315,
     IPXNETWORK = 316,
     NOVELLHACK = 317,
     NETDEV = 318,
     VNET = 319,
     DEBUG = 320,
     MOUSE = 321,
     SERIAL = 322,
     COM = 323,
     KEYBOARD = 324,
     TERMINAL = 325,
     VIDEO = 326,
     EMURETRACE = 327,
     TIMER = 328,
     MATHCO = 329,
     CPU = 330,
     CPUSPEED = 331,
     RDTSC = 332,
     BOOTA = 333,
     BOOTB = 334,
     BOOTC = 335,
     L_XMS = 336,
     L_DPMI = 337,
     DPMI_BASE = 338,
     PM_DOS_API = 339,
     NO_NULL_CHECKS = 340,
     PORTS = 341,
     DISK = 342,
     DOSMEM = 343,
     EXT_MEM = 344,
     L_EMS = 345,
     L_UMB = 346,
     EMS_SIZE = 347,
     EMS_FRAME = 348,
     TTYLOCKS = 349,
     L_SOUND = 350,
     L_SND_OSS = 351,
     L_JOYSTICK = 352,
     FULL_FILE_LOCKS = 353,
     DEXE = 354,
     ALLOWDISK = 355,
     FORCEXDOS = 356,
     XDOSONLY = 357,
     ABORT = 358,
     WARN = 359,
     BOOTDISK = 360,
     L_FLOPPY = 361,
     EMUSYS = 362,
     EMUINI = 363,
     L_X = 364,
     DOSEMUMAP = 365,
     LOGBUFSIZE = 366,
     LOGFILESIZE = 367,
     MAPPINGDRIVER = 368,
     LFN_SUPPORT = 369,
     EMULATED = 370,
     NATIVE = 371,
     CPUEMU = 372,
     VM86 = 373,
     FULL = 374,
     VM86SIM = 375,
     FULLSIM = 376,
     RAWKEYBOARD = 377,
     PRESTROKE = 378,
     KEYTABLE = 379,
     SHIFT_MAP = 380,
     ALT_MAP = 381,
     NUMPAD_MAP = 382,
     DUMP = 383,
     DGRAVE = 384,
     DACUTE = 385,
     DCIRCUM = 386,
     DTILDE = 387,
     DBREVE = 388,
     DABOVED = 389,
     DDIARES = 390,
     DABOVER = 391,
     DDACUTE = 392,
     DCEDILLA = 393,
     DIOTA = 394,
     DOGONEK = 395,
     DCARON = 396,
     NETWORK = 397,
     PKTDRIVER = 398,
     DIRECTORY = 399,
     NAMESTUB = 400,
     BINARY = 401,
     BASE = 402,
     IRQ = 403,
     INTERRUPT = 404,
     DEVICE = 405,
     CHARSET = 406,
     BAUDRATE = 407,
     VIRTUAL = 408,
     MICROSOFT = 409,
     MS3BUTTON = 410,
     LOGITECH = 411,
     MMSERIES = 412,
     MOUSEMAN = 413,
     HITACHI = 414,
     MOUSESYSTEMS = 415,
     BUSMOUSE = 416,
     PS2 = 417,
     IMPS2 = 418,
     INTERNALDRIVER = 419,
     EMULATE3BUTTONS = 420,
     CLEARDTR = 421,
     L_DISPLAY = 422,
     L_TITLE = 423,
     X_TITLE_SHOW_APPNAME = 424,
     ICON_NAME = 425,
     X_KEYCODE = 426,
     X_BLINKRATE = 427,
     X_SHARECMAP = 428,
     X_MITSHM = 429,
     X_FONT = 430,
     X_FIXED_ASPECT = 431,
     X_ASPECT_43 = 432,
     X_LIN_FILT = 433,
     X_BILIN_FILT = 434,
     X_MODE13FACT = 435,
     X_WINSIZE = 436,
     X_GAMMA = 437,
     X_FULLSCREEN = 438,
     VGAEMU_MEMSIZE = 439,
     VESAMODE = 440,
     X_LFB = 441,
     X_PM_INTERFACE = 442,
     X_MGRAB_KEY = 443,
     X_BACKGROUND_PAUSE = 444,
     VGA = 445,
     MGA = 446,
     CGA = 447,
     EGA = 448,
     NONE = 449,
     CONSOLE = 450,
     GRAPHICS = 451,
     CHIPSET = 452,
     FULLREST = 453,
     PARTREST = 454,
     MEMSIZE = 455,
     VBIOS_SIZE_TOK = 456,
     VBIOS_SEG = 457,
     VGAEMUBIOS_FILE = 458,
     VBIOS_FILE = 459,
     VBIOS_COPY = 460,
     VBIOS_MMAP = 461,
     DUALMON = 462,
     VBIOS_POST = 463,
     FORCE_VT_SWITCH = 464,
     PCI = 465,
     UPDATEFREQ = 466,
     UPDATELINES = 467,
     COLOR = 468,
     ESCCHAR = 469,
     XTERM_TITLE = 470,
     IO = 471,
     PORT = 472,
     CONFIG = 473,
     READ = 474,
     WRITE = 475,
     KEYB = 476,
     PRINTER = 477,
     WARNING = 478,
     GENERAL = 479,
     HARDWARE = 480,
     L_IPC = 481,
     SOUND = 482,
     TRACE = 483,
     CLEAR = 484,
     LPT = 485,
     COMMAND = 486,
     TIMEOUT = 487,
     L_FILE = 488,
     L_PARTITION = 489,
     BOOTFILE = 490,
     WHOLEDISK = 491,
     THREEINCH = 492,
     THREEINCH_720 = 493,
     THREEINCH_2880 = 494,
     FIVEINCH = 495,
     ATAPI = 496,
     READONLY = 497,
     LAYOUT = 498,
     SECTORS = 499,
     CYLINDERS = 500,
     TRACKS = 501,
     HEADS = 502,
     OFFSET = 503,
     HDIMAGE = 504,
     DISKCYL4096 = 505,
     RDONLY = 506,
     WRONLY = 507,
     RDWR = 508,
     ORMASK = 509,
     ANDMASK = 510,
     RANGE = 511,
     FAST = 512,
     SLOW = 513,
     SILLYINT = 514,
     USE_SIGIO = 515,
     HARDWARE_RAM = 516,
     SB_BASE = 517,
     SB_IRQ = 518,
     SB_DMA = 519,
     SB_HDMA = 520,
     SB_MIXER = 521,
     SB_DSP = 522,
     MPU_BASE = 523,
     SOUND_DRIVER = 524,
     OSS_MIN_FRAGS = 525,
     OSS_MAX_FRAGS = 526,
     OSS_STALLED_FRAGS = 527,
     OSS_DO_POST = 528,
     OSS_MIN_EXTRA_FRAGS = 529,
     OSS_DAC_FREQ = 530,
     CDROM = 531,
     ASPI = 532,
     DEVICETYPE = 533,
     TARGET = 534,
     FEATURE = 535,
     JOYSTICK = 536,
     JOY_DEVICE = 537,
     JOY_DOS_MIN = 538,
     JOY_DOS_MAX = 539,
     JOY_GRANULARITY = 540,
     JOY_LATENCY = 541,
     CLI_TIMEOUT = 542,
     PIC_WATCHDOG = 543,
     TIMEMODE = 544,
     UNICODE = 545,
     SHIFT_ALT_MAP = 546,
     CTRL_MAP = 547,
     CTRL_ALT_MAP = 548,
     INTERNAL = 549,
     EXTERNAL = 550
   };
#endif
/* Tokens.  */
#define INTEGER 258
#define L_OFF 259
#define L_ON 260
#define L_AUTO 261
#define L_YES 262
#define L_NO 263
#define CHIPSET_TYPE 264
#define KEYB_LAYOUT 265
#define REAL 266
#define STRING 267
#define VARIABLE 268
#define EXPRTEST 269
#define INTCAST 270
#define REALCAST 271
#define SHL_OP 272
#define SHR_OP 273
#define XOR_OP 274
#define OR_OP 275
#define AND_OP 276
#define NOT_OP 277
#define NEQ_OP 278
#define LE_OP 279
#define GE_OP 280
#define EQ_OP 281
#define STR_NEQ_OP 282
#define STR_EQ_OP 283
#define L_OR_OP 284
#define L_AND_OP 285
#define BIT_NOT_OP 286
#define UPLUS 287
#define UMINUS 288
#define STRLEN 289
#define STRTOL 290
#define STRNCMP 291
#define STRCAT 292
#define STRPBRK 293
#define STRSPLIT 294
#define STRCHR 295
#define STRRCHR 296
#define STRSTR 297
#define STRDEL 298
#define STRSPN 299
#define STRCSPN 300
#define SHELL 301
#define DEFINED 302
#define DEFINE 303
#define UNDEF 304
#define IFSTATEMENT 305
#define WHILESTATEMENT 306
#define FOREACHSTATEMENT 307
#define ENTER_USER_SPACE 308
#define LEAVE_USER_SPACE 309
#define CHECKUSERVAR 310
#define DOSBANNER 311
#define FASTFLOPPY 312
#define HOGTHRESH 313
#define SPEAKER 314
#define IPXSUPPORT 315
#define IPXNETWORK 316
#define NOVELLHACK 317
#define NETDEV 318
#define VNET 319
#define DEBUG 320
#define MOUSE 321
#define SERIAL 322
#define COM 323
#define KEYBOARD 324
#define TERMINAL 325
#define VIDEO 326
#define EMURETRACE 327
#define TIMER 328
#define MATHCO 329
#define CPU 330
#define CPUSPEED 331
#define RDTSC 332
#define BOOTA 333
#define BOOTB 334
#define BOOTC 335
#define L_XMS 336
#define L_DPMI 337
#define DPMI_BASE 338
#define PM_DOS_API 339
#define NO_NULL_CHECKS 340
#define PORTS 341
#define DISK 342
#define DOSMEM 343
#define EXT_MEM 344
#define L_EMS 345
#define L_UMB 346
#define EMS_SIZE 347
#define EMS_FRAME 348
#define TTYLOCKS 349
#define L_SOUND 350
#define L_SND_OSS 351
#define L_JOYSTICK 352
#define FULL_FILE_LOCKS 353
#define DEXE 354
#define ALLOWDISK 355
#define FORCEXDOS 356
#define XDOSONLY 357
#define ABORT 358
#define WARN 359
#define BOOTDISK 360
#define L_FLOPPY 361
#define EMUSYS 362
#define EMUINI 363
#define L_X 364
#define DOSEMUMAP 365
#define LOGBUFSIZE 366
#define LOGFILESIZE 367
#define MAPPINGDRIVER 368
#define LFN_SUPPORT 369
#define EMULATED 370
#define NATIVE 371
#define CPUEMU 372
#define VM86 373
#define FULL 374
#define VM86SIM 375
#define FULLSIM 376
#define RAWKEYBOARD 377
#define PRESTROKE 378
#define KEYTABLE 379
#define SHIFT_MAP 380
#define ALT_MAP 381
#define NUMPAD_MAP 382
#define DUMP 383
#define DGRAVE 384
#define DACUTE 385
#define DCIRCUM 386
#define DTILDE 387
#define DBREVE 388
#define DABOVED 389
#define DDIARES 390
#define DABOVER 391
#define DDACUTE 392
#define DCEDILLA 393
#define DIOTA 394
#define DOGONEK 395
#define DCARON 396
#define NETWORK 397
#define PKTDRIVER 398
#define DIRECTORY 399
#define NAMESTUB 400
#define BINARY 401
#define BASE 402
#define IRQ 403
#define INTERRUPT 404
#define DEVICE 405
#define CHARSET 406
#define BAUDRATE 407
#define VIRTUAL 408
#define MICROSOFT 409
#define MS3BUTTON 410
#define LOGITECH 411
#define MMSERIES 412
#define MOUSEMAN 413
#define HITACHI 414
#define MOUSESYSTEMS 415
#define BUSMOUSE 416
#define PS2 417
#define IMPS2 418
#define INTERNALDRIVER 419
#define EMULATE3BUTTONS 420
#define CLEARDTR 421
#define L_DISPLAY 422
#define L_TITLE 423
#define X_TITLE_SHOW_APPNAME 424
#define ICON_NAME 425
#define X_KEYCODE 426
#define X_BLINKRATE 427
#define X_SHARECMAP 428
#define X_MITSHM 429
#define X_FONT 430
#define X_FIXED_ASPECT 431
#define X_ASPECT_43 432
#define X_LIN_FILT 433
#define X_BILIN_FILT 434
#define X_MODE13FACT 435
#define X_WINSIZE 436
#define X_GAMMA 437
#define X_FULLSCREEN 438
#define VGAEMU_MEMSIZE 439
#define VESAMODE 440
#define X_LFB 441
#define X_PM_INTERFACE 442
#define X_MGRAB_KEY 443
#define X_BACKGROUND_PAUSE 444
#define VGA 445
#define MGA 446
#define CGA 447
#define EGA 448
#define NONE 449
#define CONSOLE 450
#define GRAPHICS 451
#define CHIPSET 452
#define FULLREST 453
#define PARTREST 454
#define MEMSIZE 455
#define VBIOS_SIZE_TOK 456
#define VBIOS_SEG 457
#define VGAEMUBIOS_FILE 458
#define VBIOS_FILE 459
#define VBIOS_COPY 460
#define VBIOS_MMAP 461
#define DUALMON 462
#define VBIOS_POST 463
#define FORCE_VT_SWITCH 464
#define PCI 465
#define UPDATEFREQ 466
#define UPDATELINES 467
#define COLOR 468
#define ESCCHAR 469
#define XTERM_TITLE 470
#define IO 471
#define PORT 472
#define CONFIG 473
#define READ 474
#define WRITE 475
#define KEYB 476
#define PRINTER 477
#define WARNING 478
#define GENERAL 479
#define HARDWARE 480
#define L_IPC 481
#define SOUND 482
#define TRACE 483
#define CLEAR 484
#define LPT 485
#define COMMAND 486
#define TIMEOUT 487
#define L_FILE 488
#define L_PARTITION 489
#define BOOTFILE 490
#define WHOLEDISK 491
#define THREEINCH 492
#define THREEINCH_720 493
#define THREEINCH_2880 494
#define FIVEINCH 495
#define ATAPI 496
#define READONLY 497
#define LAYOUT 498
#define SECTORS 499
#define CYLINDERS 500
#define TRACKS 501
#define HEADS 502
#define OFFSET 503
#define HDIMAGE 504
#define DISKCYL4096 505
#define RDONLY 506
#define WRONLY 507
#define RDWR 508
#define ORMASK 509
#define ANDMASK 510
#define RANGE 511
#define FAST 512
#define SLOW 513
#define SILLYINT 514
#define USE_SIGIO 515
#define HARDWARE_RAM 516
#define SB_BASE 517
#define SB_IRQ 518
#define SB_DMA 519
#define SB_HDMA 520
#define SB_MIXER 521
#define SB_DSP 522
#define MPU_BASE 523
#define SOUND_DRIVER 524
#define OSS_MIN_FRAGS 525
#define OSS_MAX_FRAGS 526
#define OSS_STALLED_FRAGS 527
#define OSS_DO_POST 528
#define OSS_MIN_EXTRA_FRAGS 529
#define OSS_DAC_FREQ 530
#define CDROM 531
#define ASPI 532
#define DEVICETYPE 533
#define TARGET 534
#define FEATURE 535
#define JOYSTICK 536
#define JOY_DEVICE 537
#define JOY_DOS_MIN 538
#define JOY_DOS_MAX 539
#define JOY_GRANULARITY 540
#define JOY_LATENCY 541
#define CLI_TIMEOUT 542
#define PIC_WATCHDOG 543
#define TIMEMODE 544
#define UNICODE 545
#define SHIFT_ALT_MAP 546
#define CTRL_MAP 547
#define CTRL_ALT_MAP 548
#define INTERNAL 549
#define EXTERNAL 550




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 212 "parser.y"

	int i_value;
	char *s_value;
	float r_value;
	struct {
		enum {
			TYPE_NONE,
			TYPE_INTEGER,
			TYPE_BOOLEAN,
			TYPE_REAL
		} type;
		union {
			int i;
			float r;
		} value;
	} t_value;



/* Line 293 of yacc.c  */
#line 890 "parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */

/* Line 343 of yacc.c  */
#line 230 "parser.y"

#include "lexer.h"


/* Line 343 of yacc.c  */
#line 907 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  232
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3128

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  309
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  488
/* YYNRULES -- Number of states.  */
#define YYNSTATES  924

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   550

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     306,   307,    36,    34,   308,    35,     2,    37,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   303,
      24,    23,    25,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   304,     2,   305,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    26,    27,
      28,    29,    30,    31,    32,    33,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    12,    14,    17,    22,    25,
      28,    31,    36,    43,    53,    58,    60,    62,    66,    69,
      72,    75,    78,    81,    86,    89,    92,    95,   100,   103,
     106,   109,   112,   115,   118,   121,   125,   128,   131,   133,
     135,   137,   140,   143,   146,   149,   152,   157,   160,   163,
     166,   169,   172,   175,   178,   181,   184,   187,   190,   193,
     196,   199,   202,   205,   208,   209,   215,   218,   223,   226,
     227,   233,   234,   240,   245,   246,   252,   253,   259,   260,
     267,   270,   274,   275,   281,   287,   288,   294,   295,   301,
     302,   308,   313,   322,   323,   329,   334,   337,   338,   344,
     349,   352,   357,   358,   364,   367,   372,   373,   379,   386,
     389,   392,   395,   397,   399,   401,   403,   405,   407,   409,
     413,   417,   421,   425,   428,   431,   435,   439,   441,   445,
     447,   451,   455,   459,   462,   464,   469,   474,   479,   488,
     495,   502,   509,   516,   523,   530,   532,   536,   540,   544,
     548,   552,   556,   560,   564,   568,   572,   575,   577,   579,
     581,   583,   588,   590,   595,   597,   599,   601,   606,   615,
     624,   629,   631,   633,   637,   639,   643,   645,   649,   651,
     654,   657,   660,   663,   666,   669,   672,   675,   678,   680,
     682,   685,   688,   691,   693,   695,   697,   700,   704,   709,
     712,   715,   718,   722,   727,   732,   739,   742,   745,   748,
     751,   753,   756,   758,   760,   762,   764,   767,   770,   773,
     776,   779,   782,   785,   788,   791,   793,   796,   799,   802,
     805,   808,   811,   814,   816,   819,   822,   825,   828,   831,
     834,   836,   839,   841,   843,   845,   847,   849,   852,   855,
     857,   859,   861,   863,   866,   869,   871,   873,   876,   879,
     881,   883,   885,   887,   889,   891,   893,   896,   899,   902,
     905,   907,   909,   911,   914,   917,   919,   922,   925,   928,
     931,   934,   937,   940,   943,   946,   949,   952,   955,   958,
     961,   964,   967,   970,   973,   976,   979,   982,   985,   987,
     989,   991,   994,   997,   999,  1001,  1004,  1006,  1008,  1010,
    1012,  1014,  1016,  1018,  1020,  1022,  1024,  1026,  1028,  1030,
    1032,  1035,  1038,  1039,  1046,  1049,  1052,  1055,  1057,  1059,
    1061,  1064,  1065,  1071,  1072,  1078,  1079,  1085,  1086,  1091,
    1092,  1098,  1099,  1105,  1106,  1112,  1114,  1118,  1120,  1122,
    1124,  1126,  1128,  1130,  1132,  1134,  1136,  1138,  1140,  1142,
    1144,  1146,  1148,  1152,  1154,  1156,  1159,  1162,  1165,  1167,
    1169,  1171,  1173,  1176,  1179,  1181,  1184,  1187,  1190,  1193,
    1195,  1197,  1199,  1201,  1204,  1207,  1210,  1213,  1216,  1219,
    1221,  1223,  1226,  1227,  1229,  1232,  1234,  1236,  1238,  1240,
    1242,  1244,  1246,  1249,  1252,  1255,  1258,  1261,  1265,  1268,
    1271,  1275,  1278,  1283,  1287,  1290,  1292,  1294,  1296,  1299,
    1301,  1305,  1309,  1314,  1316,  1318,  1320,  1323,  1326,  1328,
    1330,  1333,  1335,  1337,  1339,  1342,  1344,  1348,  1352,  1357,
    1359,  1361,  1363,  1365,  1368,  1370,  1374,  1377,  1381,  1386,
    1391,  1397,  1399,  1401,  1403,  1406,  1408,  1412,  1415,  1418,
    1420,  1422,  1424,  1427,  1429,  1433,  1437,  1442,  1444,  1446,
    1448,  1450,  1452,  1454,  1456,  1458,  1460,  1462,  1464,  1466,
    1468,  1470,  1472,  1474,  1476,  1478,  1480,  1483,  1486
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     310,     0,    -1,   312,    -1,   310,   312,    -1,   310,   311,
     312,    -1,   303,    -1,   311,   303,    -1,   158,   304,   396,
     305,    -1,    65,   327,    -1,    55,   334,    -1,    56,   334,
      -1,    57,   306,   327,   307,    -1,    58,     3,   308,   306,
     327,   307,    -1,    59,     3,   308,    13,   306,   335,   308,
     336,   307,    -1,    53,   306,   336,   307,    -1,    60,    -1,
      61,    -1,    13,    23,   336,    -1,    62,   338,    -1,    14,
     329,    -1,   110,   336,    -1,   111,   336,    -1,   114,   335,
      -1,   114,   304,   335,   305,    -1,   117,   335,    -1,   120,
     335,    -1,   115,   335,    -1,   115,   304,   335,   305,    -1,
     105,   390,    -1,   121,   390,    -1,    64,   391,    -1,    82,
     327,    -1,    82,   122,    -1,   124,   395,    -1,    83,   328,
      -1,    83,     3,     3,    -1,    84,   390,    -1,   217,   390,
      -1,    85,    -1,    87,    -1,    86,    -1,    80,   327,    -1,
     118,   327,    -1,   119,   327,    -1,    63,   390,    -1,    79,
     390,    -1,    97,   304,   386,   305,    -1,    97,   392,    -1,
      88,   392,    -1,    98,   390,    -1,    89,   392,    -1,    90,
     392,    -1,    91,   390,    -1,    92,   390,    -1,    95,   392,
      -1,    96,   392,    -1,    81,   390,    -1,    67,   390,    -1,
      68,   392,    -1,   150,   390,    -1,    70,   335,    -1,    69,
     390,    -1,    71,   335,    -1,    66,   394,    -1,    -1,    78,
     313,   304,   349,   305,    -1,   222,   335,    -1,    77,   304,
     351,   305,    -1,    72,   336,    -1,    -1,    72,   314,   304,
     353,   305,    -1,    -1,    73,   315,   304,   355,   305,    -1,
     101,   304,   371,   305,    -1,    -1,    74,   316,   304,   373,
     305,    -1,    -1,    76,   317,   304,   357,   305,    -1,    -1,
     131,    10,   318,   304,   360,   305,    -1,   130,   335,    -1,
     131,   135,   335,    -1,    -1,    93,   319,   304,   380,   305,
      -1,   235,    93,   304,   382,   305,    -1,    -1,    94,   320,
     304,   378,   305,    -1,    -1,   112,   321,   304,   378,   305,
      -1,    -1,   113,   322,   304,   378,   305,    -1,   283,   304,
     335,   305,    -1,   284,   304,   335,   285,   335,   286,   327,
     305,    -1,    -1,   229,   323,   304,   375,   305,    -1,   116,
     304,   339,   305,    -1,   102,   390,    -1,    -1,   102,   324,
     304,   343,   305,    -1,   103,   304,   345,   305,    -1,   104,
     390,    -1,   104,   304,   347,   305,    -1,    -1,   266,   325,
     304,   384,   305,    -1,   266,   393,    -1,   106,   304,   341,
     305,    -1,    -1,   268,   326,   304,   388,   305,    -1,   287,
     304,   327,    23,   327,   305,    -1,   294,   392,    -1,   295,
     392,    -1,   296,   335,    -1,    12,    -1,     1,    -1,   329,
      -1,   329,    -1,   330,    -1,   331,    -1,   332,    -1,   329,
      34,   329,    -1,   329,    35,   329,    -1,   329,    36,   329,
      -1,   329,    37,   329,    -1,    35,   329,    -1,    34,   329,
      -1,   329,    18,   329,    -1,   329,    17,   329,    -1,   333,
      -1,   306,   329,   307,    -1,     3,    -1,   329,    21,   329,
      -1,   329,    20,   329,    -1,   329,    19,   329,    -1,    38,
     329,    -1,     6,    -1,    15,   306,   329,   307,    -1,    42,
     306,   335,   307,    -1,    41,   306,   335,   307,    -1,    43,
     306,   335,   308,   335,   308,   327,   307,    -1,    45,   306,
     335,   308,   335,   307,    -1,    47,   306,   335,   308,   335,
     307,    -1,    48,   306,   335,   308,   335,   307,    -1,    49,
     306,   335,   308,   335,   307,    -1,    51,   306,   335,   308,
     335,   307,    -1,    52,   306,   335,   308,   335,   307,    -1,
      12,    -1,   329,    29,   329,    -1,   329,    26,   329,    -1,
     329,    28,   329,    -1,   329,    27,   329,    -1,   329,    24,
     329,    -1,   329,    25,   329,    -1,   329,    33,   329,    -1,
     329,    32,   329,    -1,   335,    31,   335,    -1,   335,    30,
     335,    -1,    22,   329,    -1,     7,    -1,     8,    -1,     5,
      -1,     4,    -1,    54,   306,   334,   307,    -1,    11,    -1,
      16,   306,   329,   307,    -1,    13,    -1,    12,    -1,   334,
      -1,    44,   306,   336,   307,    -1,    46,   306,   335,   308,
     327,   308,   327,   307,    -1,    50,   306,   335,   308,   327,
     308,   327,   307,    -1,    53,   306,   336,   307,    -1,   333,
      -1,   337,    -1,   336,   308,   337,    -1,   335,    -1,   306,
     329,   307,    -1,    13,    -1,   338,   308,    13,    -1,   340,
      -1,   339,   340,    -1,   219,   327,    -1,   218,   327,    -1,
     174,   335,    -1,   175,   335,    -1,   176,   390,    -1,   177,
     335,    -1,   178,   327,    -1,   179,   327,    -1,   180,    -1,
     181,    -1,   181,   390,    -1,   182,   335,    -1,   183,   390,
      -1,   184,    -1,   185,    -1,   186,    -1,   187,   327,    -1,
     188,     3,     3,    -1,   188,   327,   308,   327,    -1,   189,
     327,    -1,   190,   390,    -1,   191,   327,    -1,   192,     3,
       3,    -1,   192,     3,     3,     3,    -1,   192,   327,   308,
     327,    -1,   192,   327,   308,   327,   308,   327,    -1,   193,
     390,    -1,   194,   390,    -1,   195,   335,    -1,   196,   390,
      -1,   342,    -1,   341,   342,    -1,   107,    -1,   108,    -1,
     109,    -1,   344,    -1,   343,   344,    -1,   269,   327,    -1,
     271,   327,    -1,   272,   327,    -1,   270,   327,    -1,   273,
     335,    -1,   274,   335,    -1,   275,   327,    -1,   276,   335,
      -1,   346,    -1,   345,   346,    -1,   277,   327,    -1,   278,
     327,    -1,   279,   327,    -1,   280,   390,    -1,   281,   327,
      -1,   282,   327,    -1,   348,    -1,   347,   348,    -1,   289,
     335,    -1,   290,   327,    -1,   291,   327,    -1,   292,   327,
      -1,   293,   327,    -1,   350,    -1,   349,   350,    -1,   197,
      -1,   198,    -1,   199,    -1,   200,    -1,   201,    -1,   204,
       9,    -1,   207,   327,    -1,   203,    -1,   202,    -1,   205,
      -1,   206,    -1,   211,   335,    -1,   210,   335,    -1,   212,
      -1,   213,    -1,   209,   327,    -1,   208,   327,    -1,   215,
      -1,   214,    -1,   216,    -1,   217,    -1,    12,    -1,     1,
      -1,   352,    -1,   351,   352,    -1,   221,   327,    -1,   218,
     327,    -1,   220,   390,    -1,    12,    -1,     1,    -1,   354,
      -1,   353,   354,    -1,    78,   390,    -1,     4,    -1,    74,
     390,    -1,   225,   390,    -1,    94,   390,    -1,   226,   390,
      -1,   227,   390,    -1,   228,   390,    -1,    76,   390,    -1,
     229,   390,    -1,   223,   390,    -1,   224,   390,    -1,   230,
     390,    -1,   231,   390,    -1,    88,   390,    -1,    89,   390,
      -1,    73,   390,    -1,   232,   390,    -1,   233,   390,    -1,
      97,   390,    -1,   149,   390,    -1,   116,   390,    -1,   234,
     390,    -1,   288,   390,    -1,    12,    -1,     1,    -1,   356,
      -1,   355,   356,    -1,   157,   335,    -1,   171,    -1,   172,
      -1,   159,   327,    -1,   173,    -1,   161,    -1,   162,    -1,
     167,    -1,   164,    -1,   163,    -1,   169,    -1,   170,    -1,
     165,    -1,   166,    -1,   168,    -1,    12,    -1,     1,    -1,
     358,    -1,   357,   358,    -1,   250,    10,    -1,    -1,   250,
      10,   359,   304,   360,   305,    -1,   250,     8,    -1,   250,
       6,    -1,   129,   390,    -1,    12,    -1,     1,    -1,   361,
      -1,   360,   361,    -1,    -1,   299,   327,    23,   362,   369,
      -1,    -1,   298,   327,    23,   363,   369,    -1,    -1,   300,
     327,    23,   364,   369,    -1,    -1,   327,    23,   365,   369,
      -1,    -1,   132,   327,    23,   366,   369,    -1,    -1,   133,
     327,    23,   367,   369,    -1,    -1,   134,   327,    23,   368,
     369,    -1,   370,    -1,   369,   308,   370,    -1,   297,    -1,
     136,    -1,   137,    -1,   138,    -1,   139,    -1,   140,    -1,
     141,    -1,   142,    -1,   143,    -1,   144,    -1,   145,    -1,
     146,    -1,   147,    -1,   148,    -1,     3,    -1,   306,   327,
     307,    -1,   334,    -1,   372,    -1,   371,   372,    -1,   151,
     335,    -1,   152,   335,    -1,   153,    -1,    12,    -1,     1,
      -1,   374,    -1,   373,   374,    -1,   157,   335,    -1,   160,
      -1,    75,   327,    -1,   154,   327,    -1,   155,   327,    -1,
     156,   327,    -1,    73,    -1,    12,    -1,     1,    -1,   376,
      -1,   375,   376,    -1,   237,   327,    -1,   238,   335,    -1,
     239,   327,    -1,   240,   335,    -1,   154,   327,    -1,    12,
      -1,     1,    -1,   242,   335,    -1,    -1,   379,    -1,   378,
     379,    -1,   249,    -1,   244,    -1,   246,    -1,   245,    -1,
     248,    -1,   247,    -1,   257,    -1,   251,   327,    -1,   252,
     327,    -1,   253,   327,    -1,   254,   327,    -1,   255,   327,
      -1,   157,   335,   377,    -1,   240,   335,    -1,   256,   335,
      -1,   243,    12,   377,    -1,   113,   335,    -1,   241,   335,
       3,   377,    -1,   241,   335,   377,    -1,   151,   335,    -1,
      12,    -1,     1,    -1,   381,    -1,   380,   381,    -1,     3,
      -1,   306,   327,   307,    -1,   263,     3,     3,    -1,   263,
     327,   308,   327,    -1,   258,    -1,   259,    -1,   260,    -1,
     261,   327,    -1,   262,   327,    -1,   264,    -1,   265,    -1,
     157,   335,    -1,    12,    -1,     1,    -1,   383,    -1,   382,
     383,    -1,     3,    -1,   306,   327,   307,    -1,   263,     3,
       3,    -1,   263,   327,   308,   327,    -1,   236,    -1,    12,
      -1,     1,    -1,   385,    -1,   384,   385,    -1,     3,    -1,
     306,   327,   307,    -1,   267,   327,    -1,   263,     3,     3,
      -1,   263,   327,   308,   327,    -1,   267,   263,     3,     3,
      -1,   267,   263,   327,   308,   327,    -1,    12,    -1,     1,
      -1,   387,    -1,   386,   387,    -1,     3,    -1,   306,   327,
     307,    -1,    99,   327,    -1,   100,   327,    -1,    12,    -1,
       1,    -1,   389,    -1,   388,   389,    -1,     3,    -1,   306,
     327,   307,    -1,   263,     3,     3,    -1,   263,   327,   308,
     327,    -1,    12,    -1,     1,    -1,   327,    -1,   327,    -1,
     327,    -1,   327,    -1,     4,    -1,   123,    -1,   122,    -1,
      12,    -1,     1,    -1,     4,    -1,   125,    -1,   126,    -1,
     127,    -1,   128,    -1,    12,    -1,     1,    -1,   397,    -1,
     396,   397,    -1,   301,    12,    -1,   302,    12,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   359,   359,   360,   361,   364,   365,   368,   370,   371,
     372,   373,   395,   398,   402,   407,   408,   409,   428,   429,
     439,   443,   444,   449,   454,   463,   468,   473,   478,   482,
     486,   491,   501,   510,   525,   535,   545,   551,   557,   561,
     565,   569,   580,   592,   596,   601,   608,   609,   614,   619,
     624,   629,   634,   639,   644,   645,   646,   647,   652,   653,
     661,   662,   663,   664,   679,   678,   682,   683,   686,   691,
     690,   694,   693,   697,   701,   700,   705,   704,   708,   707,
     711,   717,   722,   721,   724,   726,   725,   730,   729,   734,
     733,   737,   750,   764,   763,   767,   768,   769,   769,   770,
     771,   772,   774,   773,   776,   782,   784,   783,   789,   793,
     795,   797,   803,   805,   808,   811,   816,   817,   818,   819,
     821,   823,   825,   829,   831,   833,   837,   841,   853,   856,
     857,   859,   861,   863,   865,   866,   867,   871,   875,   879,
     885,   891,   897,   903,   907,   911,   919,   921,   923,   925,
     927,   929,   931,   933,   935,   937,   939,   940,   941,   942,
     943,   944,   950,   951,   955,   972,   982,   983,   984,   997,
    1009,  1013,  1016,  1017,  1026,  1027,  1036,  1040,  1048,  1049,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1073,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1086,  1087,  1088,  1089,
    1092,  1093,  1096,  1097,  1101,  1113,  1114,  1116,  1117,  1118,
    1119,  1120,  1121,  1122,  1123,  1125,  1126,  1128,  1129,  1130,
    1131,  1132,  1133,  1138,  1139,  1141,  1142,  1143,  1144,  1145,
    1150,  1151,  1153,  1154,  1155,  1156,  1157,  1158,  1163,  1164,
    1167,  1170,  1171,  1172,  1175,  1176,  1180,  1184,  1195,  1206,
    1207,  1208,  1209,  1210,  1213,  1218,  1219,  1221,  1222,  1223,
    1224,  1227,  1236,  1237,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1265,
    1270,  1271,  1273,  1274,  1275,  1276,  1277,  1283,  1288,  1293,
    1299,  1304,  1309,  1314,  1319,  1324,  1329,  1334,  1336,  1341,
    1342,  1344,  1345,  1345,  1346,  1347,  1348,  1349,  1352,  1355,
    1356,  1359,  1359,  1360,  1360,  1361,  1361,  1362,  1362,  1363,
    1363,  1364,  1364,  1365,  1365,  1368,  1369,  1372,  1373,  1374,
    1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,  1384,
    1385,  1386,  1387,  1388,  1397,  1398,  1400,  1401,  1402,  1403,
    1405,  1410,  1411,  1413,  1415,  1427,  1429,  1430,  1431,  1432,
    1433,  1435,  1440,  1441,  1443,  1444,  1445,  1446,  1447,  1448,
    1450,  1455,  1461,  1464,  1465,  1467,  1468,  1469,  1470,  1471,
    1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1485,  1491,
    1499,  1506,  1513,  1520,  1522,  1529,  1531,  1536,  1537,  1539,
    1546,  1552,  1562,  1572,  1573,  1574,  1575,  1576,  1577,  1578,
    1579,  1580,  1583,  1586,  1587,  1589,  1591,  1593,  1595,  1597,
    1598,  1601,  1606,  1607,  1609,  1610,  1611,  1612,  1613,  1614,
    1615,  1616,  1619,  1624,  1625,  1627,  1632,  1637,  1642,  1656,
    1659,  1664,  1665,  1667,  1673,  1679,  1686,  1693,  1696,  1701,
    1704,  1707,  1715,  1724,  1725,  1726,  1727,  1729,  1734,  1735,
    1736,  1737,  1738,  1739,  1741,  1744,  1745,  1748,  1749
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INTEGER", "L_OFF", "L_ON", "L_AUTO",
  "L_YES", "L_NO", "CHIPSET_TYPE", "KEYB_LAYOUT", "REAL", "STRING",
  "VARIABLE", "EXPRTEST", "INTCAST", "REALCAST", "SHL_OP", "SHR_OP",
  "XOR_OP", "OR_OP", "AND_OP", "NOT_OP", "'='", "'<'", "'>'", "NEQ_OP",
  "LE_OP", "GE_OP", "EQ_OP", "STR_NEQ_OP", "STR_EQ_OP", "L_OR_OP",
  "L_AND_OP", "'+'", "'-'", "'*'", "'/'", "BIT_NOT_OP", "UPLUS", "UMINUS",
  "STRLEN", "STRTOL", "STRNCMP", "STRCAT", "STRPBRK", "STRSPLIT", "STRCHR",
  "STRRCHR", "STRSTR", "STRDEL", "STRSPN", "STRCSPN", "SHELL", "DEFINED",
  "DEFINE", "UNDEF", "IFSTATEMENT", "WHILESTATEMENT", "FOREACHSTATEMENT",
  "ENTER_USER_SPACE", "LEAVE_USER_SPACE", "CHECKUSERVAR", "DOSBANNER",
  "FASTFLOPPY", "HOGTHRESH", "SPEAKER", "IPXSUPPORT", "IPXNETWORK",
  "NOVELLHACK", "NETDEV", "VNET", "DEBUG", "MOUSE", "SERIAL", "COM",
  "KEYBOARD", "TERMINAL", "VIDEO", "EMURETRACE", "TIMER", "MATHCO", "CPU",
  "CPUSPEED", "RDTSC", "BOOTA", "BOOTB", "BOOTC", "L_XMS", "L_DPMI",
  "DPMI_BASE", "PM_DOS_API", "NO_NULL_CHECKS", "PORTS", "DISK", "DOSMEM",
  "EXT_MEM", "L_EMS", "L_UMB", "EMS_SIZE", "EMS_FRAME", "TTYLOCKS",
  "L_SOUND", "L_SND_OSS", "L_JOYSTICK", "FULL_FILE_LOCKS", "DEXE",
  "ALLOWDISK", "FORCEXDOS", "XDOSONLY", "ABORT", "WARN", "BOOTDISK",
  "L_FLOPPY", "EMUSYS", "EMUINI", "L_X", "DOSEMUMAP", "LOGBUFSIZE",
  "LOGFILESIZE", "MAPPINGDRIVER", "LFN_SUPPORT", "EMULATED", "NATIVE",
  "CPUEMU", "VM86", "FULL", "VM86SIM", "FULLSIM", "RAWKEYBOARD",
  "PRESTROKE", "KEYTABLE", "SHIFT_MAP", "ALT_MAP", "NUMPAD_MAP", "DUMP",
  "DGRAVE", "DACUTE", "DCIRCUM", "DTILDE", "DBREVE", "DABOVED", "DDIARES",
  "DABOVER", "DDACUTE", "DCEDILLA", "DIOTA", "DOGONEK", "DCARON",
  "NETWORK", "PKTDRIVER", "DIRECTORY", "NAMESTUB", "BINARY", "BASE", "IRQ",
  "INTERRUPT", "DEVICE", "CHARSET", "BAUDRATE", "VIRTUAL", "MICROSOFT",
  "MS3BUTTON", "LOGITECH", "MMSERIES", "MOUSEMAN", "HITACHI",
  "MOUSESYSTEMS", "BUSMOUSE", "PS2", "IMPS2", "INTERNALDRIVER",
  "EMULATE3BUTTONS", "CLEARDTR", "L_DISPLAY", "L_TITLE",
  "X_TITLE_SHOW_APPNAME", "ICON_NAME", "X_KEYCODE", "X_BLINKRATE",
  "X_SHARECMAP", "X_MITSHM", "X_FONT", "X_FIXED_ASPECT", "X_ASPECT_43",
  "X_LIN_FILT", "X_BILIN_FILT", "X_MODE13FACT", "X_WINSIZE", "X_GAMMA",
  "X_FULLSCREEN", "VGAEMU_MEMSIZE", "VESAMODE", "X_LFB", "X_PM_INTERFACE",
  "X_MGRAB_KEY", "X_BACKGROUND_PAUSE", "VGA", "MGA", "CGA", "EGA", "NONE",
  "CONSOLE", "GRAPHICS", "CHIPSET", "FULLREST", "PARTREST", "MEMSIZE",
  "VBIOS_SIZE_TOK", "VBIOS_SEG", "VGAEMUBIOS_FILE", "VBIOS_FILE",
  "VBIOS_COPY", "VBIOS_MMAP", "DUALMON", "VBIOS_POST", "FORCE_VT_SWITCH",
  "PCI", "UPDATEFREQ", "UPDATELINES", "COLOR", "ESCCHAR", "XTERM_TITLE",
  "IO", "PORT", "CONFIG", "READ", "WRITE", "KEYB", "PRINTER", "WARNING",
  "GENERAL", "HARDWARE", "L_IPC", "SOUND", "TRACE", "CLEAR", "LPT",
  "COMMAND", "TIMEOUT", "L_FILE", "L_PARTITION", "BOOTFILE", "WHOLEDISK",
  "THREEINCH", "THREEINCH_720", "THREEINCH_2880", "FIVEINCH", "ATAPI",
  "READONLY", "LAYOUT", "SECTORS", "CYLINDERS", "TRACKS", "HEADS",
  "OFFSET", "HDIMAGE", "DISKCYL4096", "RDONLY", "WRONLY", "RDWR", "ORMASK",
  "ANDMASK", "RANGE", "FAST", "SLOW", "SILLYINT", "USE_SIGIO",
  "HARDWARE_RAM", "SB_BASE", "SB_IRQ", "SB_DMA", "SB_HDMA", "SB_MIXER",
  "SB_DSP", "MPU_BASE", "SOUND_DRIVER", "OSS_MIN_FRAGS", "OSS_MAX_FRAGS",
  "OSS_STALLED_FRAGS", "OSS_DO_POST", "OSS_MIN_EXTRA_FRAGS",
  "OSS_DAC_FREQ", "CDROM", "ASPI", "DEVICETYPE", "TARGET", "FEATURE",
  "JOYSTICK", "JOY_DEVICE", "JOY_DOS_MIN", "JOY_DOS_MAX",
  "JOY_GRANULARITY", "JOY_LATENCY", "CLI_TIMEOUT", "PIC_WATCHDOG",
  "TIMEMODE", "UNICODE", "SHIFT_ALT_MAP", "CTRL_MAP", "CTRL_ALT_MAP",
  "INTERNAL", "EXTERNAL", "';'", "'{'", "'}'", "'('", "')'", "','",
  "$accept", "lines", "optdelim", "line", "$@1", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "expression", "real_expression", "typed_expr", "int_expr",
  "bool_expr", "real_expr", "variable_content", "string_unquoted",
  "string_expr", "strarglist", "strarglist_item", "check_user_var_list",
  "x_flags", "x_flag", "dexeflags", "dexeflag", "sound_flags",
  "sound_flag", "snd_oss_flags", "snd_oss_flag", "joystick_flags",
  "joystick_flag", "video_flags", "video_flag", "term_flags", "term_flag",
  "debug_flags", "debug_flag", "mouse_flags", "mouse_flag",
  "keyboard_flags", "keyboard_flag", "$@15", "keyboard_mods",
  "keyboard_mod", "$@16", "$@17", "$@18", "$@19", "$@20", "$@21", "$@22",
  "keyboard_modvals", "keyboard_modval", "ttylocks_flags", "ttylocks_flag",
  "serial_flags", "serial_flag", "printer_flags", "printer_flag",
  "optbootfile", "disk_flags", "disk_flag", "port_flags", "port_flag",
  "trace_port_flags", "trace_port_flag", "sillyint_flags", "sillyint_flag",
  "ems_flags", "ems_flag", "hardware_ram_flags", "hardware_ram_flag",
  "bool", "floppy_bool", "int_bool", "irq_bool", "speaker", "cpuemu",
  "charset_flags", "charset_flag", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    61,    60,    62,   278,   279,   280,   281,
     282,   283,   284,   285,    43,    45,    42,    47,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,    59,   123,   125,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   309,   310,   310,   310,   311,   311,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   313,   312,   312,   312,   312,   314,
     312,   315,   312,   312,   316,   312,   317,   312,   318,   312,
     312,   312,   319,   312,   312,   320,   312,   321,   312,   322,
     312,   312,   312,   323,   312,   312,   312,   324,   312,   312,
     312,   312,   325,   312,   312,   312,   326,   312,   312,   312,
     312,   312,   312,   312,   327,   328,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   330,
     330,   330,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   330,   330,   330,   330,   331,   331,   331,   331,
     331,   331,   331,   331,   331,   331,   331,   331,   331,   331,
     331,   331,   332,   332,   333,   334,   335,   335,   335,   335,
     335,   335,   336,   336,   337,   337,   338,   338,   339,   339,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     341,   341,   342,   342,   342,   343,   343,   344,   344,   344,
     344,   344,   344,   344,   344,   345,   345,   346,   346,   346,
     346,   346,   346,   347,   347,   348,   348,   348,   348,   348,
     349,   349,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   351,   351,   352,   352,   352,
     352,   352,   353,   353,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     355,   355,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   356,   357,
     357,   358,   359,   358,   358,   358,   358,   358,   358,   360,
     360,   362,   361,   363,   361,   364,   361,   365,   361,   366,
     361,   367,   361,   368,   361,   369,   369,   370,   370,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   370,
     370,   370,   370,   370,   371,   371,   372,   372,   372,   372,
     372,   373,   373,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   375,   375,   376,   376,   376,   376,   376,   376,
     376,   377,   377,   378,   378,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   380,   380,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   382,   382,   383,   383,   383,   383,   383,
     383,   383,   384,   384,   385,   385,   385,   385,   385,   385,
     385,   385,   385,   386,   386,   387,   387,   387,   387,   387,
     387,   388,   388,   389,   389,   389,   389,   389,   389,   390,
     391,   392,   393,   394,   394,   394,   394,   394,   395,   395,
     395,   395,   395,   395,   395,   396,   396,   397,   397
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     3,     1,     2,     4,     2,     2,
       2,     4,     6,     9,     4,     1,     1,     3,     2,     2,
       2,     2,     2,     4,     2,     2,     2,     4,     2,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     1,     1,
       1,     2,     2,     2,     2,     2,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     5,     2,     4,     2,     0,
       5,     0,     5,     4,     0,     5,     0,     5,     0,     6,
       2,     3,     0,     5,     5,     0,     5,     0,     5,     0,
       5,     4,     8,     0,     5,     4,     2,     0,     5,     4,
       2,     4,     0,     5,     2,     4,     0,     5,     6,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     2,     2,     3,     3,     1,     3,     1,
       3,     3,     3,     2,     1,     4,     4,     4,     8,     6,
       6,     6,     6,     6,     6,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     1,     1,     1,
       1,     4,     1,     4,     1,     1,     1,     4,     8,     8,
       4,     1,     1,     3,     1,     3,     1,     3,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     2,     2,     1,     1,     1,     2,     3,     4,     2,
       2,     2,     3,     4,     4,     6,     2,     2,     2,     2,
       1,     2,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     1,     2,     2,     2,     2,     2,     2,
       1,     2,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     2,     2,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       1,     1,     1,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     2,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     0,     6,     2,     2,     2,     1,     1,     1,
       2,     0,     5,     0,     5,     0,     5,     0,     4,     0,
       5,     0,     5,     0,     5,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     2,     2,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     2,     1,
       1,     2,     0,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     3,     2,     2,
       3,     2,     4,     3,     2,     1,     1,     1,     2,     1,
       3,     3,     4,     1,     1,     1,     2,     2,     1,     1,
       2,     1,     1,     1,     2,     1,     3,     3,     4,     1,
       1,     1,     1,     2,     1,     3,     2,     3,     4,     4,
       5,     1,     1,     1,     2,     1,     3,     2,     2,     1,
       1,     1,     2,     1,     3,     3,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,   113,   112,     0,     0,     0,     0,     0,     0,     0,
       0,    15,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,    71,    74,    76,     0,    64,     0,
       0,     0,     0,     0,     0,    38,    40,    39,     0,     0,
       0,     0,     0,    82,    85,     0,     0,     0,     0,     0,
      97,     0,     0,     0,     0,     0,     0,    87,    89,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    93,     0,   102,   106,     0,     0,
       0,     0,     0,     0,     0,     2,     0,   129,   160,   159,
     134,   157,   158,   162,   145,   164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    19,   116,   117,
     118,   127,   166,     0,     0,   165,     9,    10,     0,     0,
       0,   176,    18,   469,   114,    44,   470,    30,     8,   477,
     473,   476,   475,   474,    63,    57,   471,    58,    61,   171,
      60,    62,     0,     0,   174,    68,   172,     0,     0,     0,
       0,     0,    45,    41,    56,    32,    31,   129,    34,   115,
      36,    48,    50,    51,    52,    53,     0,     0,    54,    55,
       0,    47,    49,     0,     0,    96,     0,     0,   100,    28,
       0,    20,    21,     0,     0,     0,    22,     0,    26,     0,
      24,    42,    43,    25,    29,   484,   478,   483,   479,   480,
     481,   482,    33,    80,    78,     0,    59,     0,    37,    66,
       0,     0,     0,   472,   104,     0,     0,     0,     0,   109,
     110,   111,     1,     5,     0,     3,    17,     0,     0,   156,
     124,   123,   133,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   271,   270,
       0,     0,     0,     0,   265,     0,    35,     0,     0,   460,
     455,   459,     0,     0,     0,     0,   453,   370,   369,     0,
       0,   368,     0,   364,     0,     0,     0,     0,     0,     0,
       0,     0,   225,     0,     0,     0,     0,     0,     0,   233,
     212,   213,   214,     0,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   188,   189,     0,     0,   193,
     194,   195,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   178,     0,    81,     0,     0,
       0,   485,     0,     0,     0,     0,     0,     0,     0,     6,
       4,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   128,   126,   125,
     132,   131,   130,   150,   151,   147,   149,   148,   146,   153,
     152,   119,   120,   121,   122,   155,   154,    14,    11,     0,
       0,   177,   175,   299,   275,   298,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     272,   173,   318,   317,     0,     0,   307,   308,   311,   310,
     314,   315,   309,   316,   312,   313,   303,   304,   306,     0,
     300,   381,   380,   379,     0,     0,     0,     0,     0,   374,
       0,   371,   328,   327,     0,     0,     0,   319,   268,   269,
     267,    67,   266,   264,   263,   242,   243,   244,   245,   246,
     250,   249,     0,   251,   252,     0,     0,     0,     0,     0,
     255,   256,   260,   259,   261,   262,     0,   240,   432,   419,
     431,     0,   423,   424,   425,     0,     0,     0,   428,   429,
       0,     0,   417,   416,   415,     0,     0,     0,     0,     0,
       0,   396,   398,   397,   400,   399,   395,     0,     0,     0,
       0,     0,     0,   401,     0,   393,   457,   458,     0,    46,
     454,   366,   367,    73,   365,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   215,   227,   228,   229,   230,   231,
     232,    99,   226,   235,   236,   237,   238,   239,   101,   234,
     105,   211,     0,     0,    23,    27,   182,   183,   184,   185,
     186,   187,   190,   191,   192,   196,   129,     0,   199,   200,
     201,   129,     0,   206,   207,   208,   209,   181,   180,    95,
     179,     0,   487,   488,     7,   486,   390,   389,     0,     0,
       0,     0,     0,     0,   382,   441,   435,   440,   439,     0,
       0,     0,   433,   452,   444,   451,     0,     0,     0,     0,
     442,   468,   463,   467,     0,     0,     0,   461,    91,     0,
       0,   135,   163,   137,   136,     0,   167,     0,     0,     0,
       0,     0,     0,     0,     0,   170,   161,     0,     0,   290,
     276,   282,   274,   288,   289,   278,   293,   295,   294,   284,
     285,   277,   279,   280,   281,   283,   286,   287,   291,   292,
     296,   297,    70,   273,   302,   305,    72,   301,   375,   376,
     377,   378,   373,    75,   372,   326,   325,   324,   321,    77,
     320,   247,   248,   258,   257,   254,   253,    65,   241,   430,
     426,   427,   129,     0,     0,    83,   418,   411,   414,   392,
     408,   392,   392,   402,   403,   404,   405,   406,   409,    86,
     394,   456,   217,   220,   218,   219,   221,   222,   223,   224,
      98,   216,    88,    90,   197,     0,   202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   329,   388,   384,   385,
     386,   387,    94,   383,   129,     0,     0,    84,   434,   129,
       0,     0,   446,     0,   103,   443,   129,     0,     0,   107,
     462,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    12,     0,     0,   421,     0,   420,     0,   407,
     392,   413,   410,   198,   203,   204,     0,     0,     0,     0,
       0,     0,   337,    79,   330,   437,     0,   436,   447,     0,
     129,     0,   445,   465,     0,   464,     0,   108,     0,   139,
       0,   140,   141,   142,     0,   143,   144,     0,     0,   422,
     391,   412,     0,   339,   341,   343,   333,   331,   335,     0,
     438,   448,   449,     0,   466,     0,     0,     0,     0,     0,
       0,   205,     0,     0,     0,     0,     0,     0,   361,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   347,     0,   363,   338,   345,   450,    92,   138,
     168,   169,    13,   323,   340,   342,   344,   334,   332,   336,
       0,     0,   362,   346
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    84,   234,    85,   161,   153,   157,   158,   159,   366,
     176,   177,   193,   194,   220,   184,   222,   225,   133,   168,
     134,   118,   119,   120,   121,   122,   123,   155,   156,   132,
     364,   365,   333,   334,   573,   574,   321,   322,   328,   329,
     516,   517,   293,   294,   449,   450,   469,   470,   486,   487,
     814,   775,   776,   886,   885,   887,   869,   882,   883,   884,
     905,   906,   312,   313,   480,   481,   633,   634,   819,   554,
     555,   531,   532,   641,   642,   649,   650,   305,   306,   656,
     657,   135,   137,   147,   224,   144,   212,   370,   371
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -761
static const yytype_int16 yypact[] =
{
    2719,  -761,  -761,   -11,  2018,  -290,    16,    16,  -270,    37,
      41,  -761,  -761,    25,  2018,  2018,  2018,   197,  2018,  2018,
    2018,   373,   373,    75,  -761,  -761,  -761,  -258,  -761,  2018,
    2018,  2018,  1279,  2080,  2018,  -761,  -761,  -761,  2018,  2018,
    2018,  2018,  2018,  -761,  -761,  2018,  2018,  1813,  2018,  -248,
    2018,  -245,  1883,  2018,  -215,    75,    75,  -761,  -761,    85,
     110,  -212,   373,  2018,  2018,   373,  2018,    92,   373,    -1,
    2018,  -210,  2018,   373,  -761,   -29,  2018,  -761,  -204,  -196,
    -192,  2018,  2018,   373,  1485,  -761,    75,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,    96,  -761,  -182,  -159,  2018,  2018,
    2018,  2018,  -153,  -151,  -137,  -123,  -112,  -104,  -101,  -100,
     -93,   -90,   -58,   -57,   -54,   -52,  2018,  1390,  -761,  -761,
    -761,   102,  -761,   109,    75,  -761,  -761,  -761,  2018,  -194,
    -143,  -761,   -32,  -761,  1390,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  2018,   -23,  -761,   -26,  -761,   -19,   -16,   -12,
     106,     4,  -761,  -761,  -761,  -761,  -761,   290,  -761,  1390,
    -761,  -761,  -761,  -761,  -761,  -761,     6,    14,  -761,  -761,
      46,  -761,  -761,   202,    21,  -761,   262,   -68,  -761,  -761,
      35,   -26,   -26,    34,    47,   373,  -761,   373,  -761,  2843,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,   373,  -761,  -165,  -761,  -761,
      72,    80,    83,  -761,  -761,    84,   373,   373,  2018,  -761,
    -761,  -761,  -761,  -761,  2470,  -761,   -26,  2018,  2018,   636,
    -761,  -761,  -761,   373,   373,   373,    75,   373,   373,   373,
     373,   373,   373,   373,   373,    75,    16,   411,  2018,  2018,
    2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,
    2018,  2018,  2018,  2018,  2018,   373,   373,  -149,    26,    39,
     333,   357,  1065,  2840,    75,     9,   410,    79,  -761,  -761,
    2018,  2018,  2018,    66,  -761,  2461,  -761,    36,   795,  -761,
    -761,  -761,  2018,  2018,  2018,    17,  -761,  -761,  -761,   373,
     373,  -761,    59,  -761,   200,  2018,  2018,  2018,  2018,  2018,
    2018,   172,  -761,   373,  2018,  2018,  2018,  2018,  -141,  -761,
    -761,  -761,  -761,   -25,  -761,   795,   795,    77,    87,   373,
     373,  2018,   373,  2018,  2018,  -761,  2018,   373,  2018,  -761,
    -761,  -761,  2018,  2132,  2018,  2018,  2018,  2187,  2018,  2018,
     373,  2018,  2018,  2018,  2706,  -761,    89,  -761,   365,   366,
    -240,  -761,   361,    73,    98,    74,    91,   113,   378,  -761,
    -761,  1114,  1162,    95,   100,    97,  -146,   101,   104,   105,
     107,   108,   112,   116,   117,  -119,   120,  -761,   636,   636,
     636,   636,   636,   539,   539,   539,   539,   539,   539,   452,
     452,   155,   155,  -761,  -761,  -761,  -761,  -761,  -761,  2018,
     127,  -761,  -761,  -761,  -761,  -761,  2018,  2018,  2018,  2018,
    2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,
    2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,  2018,  1161,
    -761,  -761,  -761,  -761,   373,  2018,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,    94,
    -761,  -761,  -761,  -761,  2018,  2018,  2018,  2018,   373,  -761,
      30,  -761,  -761,  -761,  2018,   103,    78,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,   401,  -761,  -761,  2018,  2018,  2018,   373,   373,
    -761,  -761,  -761,  -761,  -761,  -761,    29,  -761,  -761,  -761,
    -761,   373,  -761,  -761,  -761,  2018,  2018,  2239,  -761,  -761,
    2018,    10,  -761,  -761,  -761,   373,   373,   373,   373,   373,
     429,  -761,  -761,  -761,  -761,  -761,  -761,  2018,  2018,  2018,
    2018,  2018,   373,  -761,   456,  -761,  -761,  -761,   148,  -761,
    -761,  -761,  -761,  -761,  -761,  2018,  2018,  2018,  2018,   373,
     373,  2018,   373,   251,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,   479,   776,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,   453,   150,  -761,  -761,
    -761,   457,   157,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  1751,  -761,  -761,  -761,  -761,  -761,  -761,  2018,  2018,
     373,  2018,   373,   129,  -761,  -761,  -761,  -761,  -761,  2291,
    2018,    42,  -761,  -761,  -761,  -761,  2346,  1950,  2018,    54,
    -761,  -761,  -761,  -761,  2398,  2018,    69,  -761,  -761,   373,
    2018,  -761,  -761,  -761,  -761,   373,  -761,   373,  2018,   373,
     373,   373,  2018,   373,   373,  -761,  -761,   159,   373,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,   163,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,   475,   171,   174,  -761,  -761,  -761,  -761,   240,
    -761,     5,   240,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  2018,   481,  2018,  2018,  2018,
    2018,  2018,  2018,  2018,   467,  1614,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,   492,   201,   203,  -761,  -761,   508,
     208,  2453,  -761,   211,  -761,  -761,   516,   220,   222,  -761,
    -761,   245,   228,   237,   239,   241,   244,   250,   252,   255,
     253,   261,  -761,   269,   243,  -761,  2018,  -761,   373,  -761,
     240,  -761,  -761,  -761,  -761,   283,   525,   570,   571,   582,
     583,   586,  -761,  -761,  -761,  -761,  2018,  -761,  -761,  2018,
     609,   306,  -761,  -761,  2018,  -761,  2018,  -761,  2018,  -761,
    2018,  -761,  -761,  -761,  2018,  -761,  -761,    75,  1751,  -761,
    -761,  -761,  2018,  -761,  -761,  -761,  -761,  -761,  -761,   360,
    -761,  -761,  -761,  2018,  -761,   312,   321,   322,   324,  -111,
    1681,  -761,   360,   360,   360,   360,   360,   360,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  2018,  -761,   329,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,   329,   329,   329,   329,   329,   329,
     325,   360,  -761,  -761
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -761,  -761,  -761,   -77,  -761,  -761,  -761,  -761,  -761,  -761,
    -761,  -761,  -761,  -761,  -761,  -761,  -761,  -761,   -13,  -761,
    2822,  -761,  -761,  -761,   335,    -6,   861,   -51,   356,  -761,
    -761,   279,  -761,   313,  -761,    76,  -761,   327,  -761,   323,
    -761,   134,  -761,   359,  -761,   204,  -761,   185,  -761,   170,
    -761,  -191,  -760,  -761,  -761,  -761,  -761,  -761,  -761,  -761,
    -262,  -243,  -761,   364,  -761,   199,  -761,    48,  -718,  -136,
    -540,  -761,   149,  -761,    43,  -761,    38,  -761,   380,  -761,
      27,   920,  -761,   557,  -761,  -761,  -761,  -761,   316
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -323
static const yytype_int16 yytable[] =
{
     126,   127,   136,   138,   191,   192,   146,   235,   820,   214,
     452,   518,    86,   519,   750,   834,   124,   163,   299,   166,
     300,   453,   520,   821,   822,   146,   146,   146,   125,   301,
     493,   471,   146,   146,   146,   236,   128,   518,   131,   519,
     129,   494,   472,   635,   130,   636,   160,   299,   520,   300,
     201,   202,   750,   750,   637,   643,   183,   644,   301,   186,
     307,   368,   369,   223,   221,   624,   645,   288,   146,   146,
     651,   308,   652,   277,   635,   651,   636,   652,   289,   482,
     482,   653,   330,   331,   332,   637,   653,   125,    95,   190,
     483,   483,   199,   205,   217,   452,   206,   125,    95,   643,
     226,   644,   861,   473,   207,   474,   453,   288,   227,   716,
     645,   717,   228,   718,   279,   278,   302,   303,   289,   105,
     834,   107,   125,    95,   237,   111,  -165,  -165,   114,   105,
     626,   107,  -171,  -171,   215,   111,   368,   369,   114,   275,
     276,   627,   330,   331,   332,   302,   303,   238,   323,   324,
     325,   326,   327,   243,   105,   244,   107,   380,   417,   284,
     111,   666,   284,   114,   588,   280,   454,   521,   455,   245,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   246,   475,   476,   477,   478,   675,   284,
     479,   273,   274,   521,   247,   386,   912,   284,   139,   592,
     593,   140,   248,   307,   395,   249,   250,   484,   484,   141,
     309,   310,   311,   251,   308,   378,   252,   208,   209,   210,
     211,   323,   324,   325,   326,   327,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   818,   253,   254,
     396,   454,   255,   455,   256,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   522,   523,
     524,   525,   526,   527,   528,   529,   281,   488,   638,   490,
     590,   283,   284,   628,   290,   285,   291,   292,   286,   556,
     557,   558,   287,   296,   522,   523,   524,   525,   526,   527,
     528,   529,   575,   576,   577,   639,   579,   580,   295,   638,
     297,   584,   585,   586,   587,   735,   530,   646,   298,   142,
     143,   647,   559,   304,   290,   314,   291,   292,   485,   485,
     600,   601,   654,   418,   727,   713,   639,   654,   335,   605,
     607,   608,   530,   610,   612,   419,   420,   787,   640,   617,
     618,   336,   304,   309,   310,   311,   149,   149,   149,   794,
     648,   646,   626,   888,   563,   647,   629,   630,   631,   632,
     421,   491,   125,   627,   799,   655,   372,   622,   623,   640,
     655,   152,   594,   719,   373,   125,    95,   374,   375,   195,
     149,   149,   595,   621,   149,   149,   658,   149,   659,   706,
     149,   660,   663,   149,   648,   665,   677,   664,   149,   667,
     721,   471,   668,   669,   197,   670,   671,   105,   149,   107,
     672,   149,   472,   111,   673,   674,   114,   676,   258,   259,
     260,   261,   262,   678,   782,   263,   264,   265,   266,   267,
     268,   742,   705,   269,   270,   271,   272,   273,   274,   315,
     316,   317,   318,   319,   320,   751,   764,   533,   765,   149,
     766,   708,   709,   710,   711,   767,   812,  -322,   534,   565,
     566,   567,   568,   569,   570,   571,   572,   581,   815,   816,
     533,   817,   818,   473,   824,   474,   271,   272,   273,   274,
     832,   534,   722,   723,   724,   835,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   836,
     837,   838,   730,   731,   733,   628,   839,   734,   842,   843,
     565,   566,   567,   568,   569,   570,   571,   572,   844,   845,
     149,   846,   149,   847,   743,   744,   745,   746,   747,   315,
     316,   317,   318,   319,   320,   848,   849,   858,   863,   850,
     149,   851,   752,   753,   754,   755,   760,   852,   758,   853,
     855,   149,   149,   854,   475,   476,   477,   478,   856,   535,
     479,   269,   270,   271,   272,   273,   274,   857,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   862,   535,   864,   865,   171,   172,   173,   629,   630,
     631,   632,   178,   179,   181,   866,   867,   536,   774,   868,
     149,   149,   872,   537,   873,   777,   778,   908,   780,   149,
     914,   915,   916,   917,   918,   919,   785,   786,   909,   910,
     536,   911,   922,   790,   792,   793,   537,   921,   229,   230,
     451,   797,   798,   620,   149,   149,   591,   802,   582,   761,
     728,   589,   492,   703,   707,   805,   720,   902,   149,   809,
     263,   264,   265,   266,   267,   268,   903,   880,   269,   270,
     271,   272,   273,   274,   149,   149,   564,   149,   923,   714,
     736,   783,   149,   800,   788,   560,   625,   795,     0,     0,
       0,     0,     0,     0,     0,   149,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,     0,   547,   548,   549,
     550,   551,   552,   553,     0,     0,     0,     0,   397,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,     0,
     547,   548,   549,   550,   551,   552,   553,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   823,     0,   825,   826,   827,   828,   829,   830,
     831,   749,   774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   533,   841,     0,
       0,     0,     0,     0,   762,     0,     0,     0,   534,   149,
       0,     0,     0,     0,     0,     0,   533,     0,     0,     0,
       0,     0,     0,   859,     0,     0,   879,   534,     0,     0,
       0,     0,     0,   149,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   870,     0,     0,   871,     0,     0,     0,
       0,   874,     0,   875,     0,   876,     0,   877,     0,     0,
       0,   878,     0,   149,   149,   774,     0,     0,     0,   881,
       0,     0,     0,     0,     0,     0,   149,     0,     0,     0,
     907,     0,     0,   904,     0,     0,     0,   774,     0,     0,
     149,   149,   149,   149,   149,     0,   904,   904,   904,   904,
     904,   904,   150,   151,   154,     0,     0,   149,     0,   535,
     920,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   149,   149,     0,   149,   535,     0,
       0,     0,     0,     0,     0,   904,   154,   154,     0,     0,
     196,   198,     0,   200,     0,     0,   203,   536,     0,   213,
       0,     0,     0,   537,   219,     0,     0,     0,   145,     0,
     148,     0,     0,     0,   231,     0,   536,   154,     0,   162,
       0,   164,   537,     0,   170,     0,     0,     0,     0,     0,
       0,   174,   175,     0,     0,   149,     0,   149,   182,     0,
     185,     0,   188,   189,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   154,   204,     0,     0,     0,
     216,     0,   218,     0,   149,     0,     0,     0,     0,     0,
     149,     0,   149,     0,   149,   149,   149,     0,   149,   149,
       0,     0,     0,   149,     0,     0,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,     0,   547,   548,   549,
     550,   551,   552,   553,     0,   538,   539,     0,   540,   541,
     542,   543,   544,   545,   546,     0,   547,   548,   549,   550,
     551,   552,   553,     0,     0,     0,   337,     0,   338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   367,     0,     0,     0,
       0,   763,   258,   259,   260,   261,   262,   376,   377,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   271,
     272,   273,   274,     0,   383,   384,   385,   154,   387,   388,
     389,   390,   391,   392,   393,   394,   154,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   258,   259,   260,   261,   262,   415,   416,   263,   264,
     265,   266,   267,   268,     0,   154,   269,   270,   271,   272,
     273,   274,     0,   149,     0,     0,     0,     0,     0,     0,
       0,     0,   423,     0,     0,   424,     0,     0,     0,     0,
     561,   562,     0,   425,     0,     0,     0,     0,     0,   258,
     259,   260,   261,   262,   583,     0,   263,   264,   265,   266,
     267,   268,   149,     0,   269,   270,   271,   272,   273,   274,
     596,   597,     0,   599,     0,     0,     0,     0,   603,     0,
       0,   489,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   615,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   426,   427,     0,   428,   578,   429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   430,
     431,     0,     0,     0,     0,   432,     0,     0,   433,     0,
       0,   598,     0,     0,     0,     0,   602,     0,   604,     0,
       0,     0,     0,     0,     0,   609,     0,   434,   613,   614,
       0,   616,    87,    88,    89,    90,    91,    92,     0,     0,
      93,    94,    95,     0,    96,    97,     0,     0,     0,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
     435,     0,     0,    99,   100,   704,     0,   101,     0,     0,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,     0,     0,   712,
       0,     0,     0,     0,     0,     0,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   725,
     726,     0,   422,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   729,     0,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   737,   738,   739,   740,
     741,   165,     0,     0,   715,     0,     0,   258,   259,   260,
     261,   262,     0,   748,   263,   264,   265,   266,   267,   268,
       0,   661,   269,   270,   271,   272,   273,   274,     0,     0,
     756,   757,     0,   759,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   448,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   702,     0,     0,   662,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   232,     1,     0,     0,     0,
       0,   779,     0,   781,     0,     0,     0,     2,     3,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     801,     0,     0,     0,     0,     0,   803,     0,   804,     0,
     806,   807,   808,     0,   810,   811,     0,     0,     5,   813,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
       0,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,     0,   116,    49,    50,    51,    52,
      53,    54,     0,     0,     0,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,     0,     0,    67,
       0,     0,     0,     0,     0,    68,    69,    87,    88,    89,
      90,    91,    92,     0,     0,    93,    94,    95,     0,    96,
      97,     0,     0,     0,     0,    70,    98,     0,     0,     0,
       0,     0,     0,    71,     0,     0,     0,     0,    99,   100,
       0,     0,   101,     0,     0,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   860,
       0,     0,     0,     0,    87,    88,    89,    90,    91,    92,
       0,     0,    93,    94,    95,     0,    96,    97,     0,     0,
       0,     0,    72,    98,     0,     0,     0,    73,     0,     0,
       0,     0,     0,     0,    74,    99,   100,     0,   154,   101,
      75,     0,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   768,   769,   770,     0,
       0,    76,     0,    77,    87,    88,    89,    90,    91,    92,
       0,     0,    93,    94,    95,     0,    96,    97,    78,    79,
       0,     0,    80,    98,     0,     0,     0,     0,     0,    81,
      82,    83,     0,     0,     0,    99,   100,     0,   233,   101,
       0,     0,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,     0,
       0,     0,     0,   768,   769,   770,    87,    88,    89,    90,
      91,    92,     0,     0,    93,    94,    95,     0,    96,    97,
       0,     0,     0,     0,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    99,   100,     0,
       0,   101,     0,     0,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   768,   769,   770,    87,    88,    89,    90,
      91,    92,     0,     0,    93,    94,    95,     0,    96,    97,
       0,     0,     0,     0,     0,    98,     0,     0,     0,     0,
       0,     0,   771,   772,   773,     0,     0,    99,   100,   833,
     116,   101,     0,     0,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,    88,    89,    90,    91,    92,     0,
       0,    93,    94,    95,     0,    96,    97,     0,     0,     0,
       0,     0,    98,     0,     0,     0,     0,     0,     0,   771,
     772,   773,     0,     0,    99,   100,   913,   116,   101,     0,
       0,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,     0,    96,    97,     0,     0,     0,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,   771,
     772,   773,    99,   100,     0,     0,   101,   116,     0,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   167,    88,    89,    90,    91,    92,     0,
       0,    93,    94,    95,     0,    96,    97,     0,     0,     0,
       0,     0,    98,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    99,   100,     0,   180,   101,   116,
       0,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   606,    88,    89,    90,    91,
      92,     0,     0,    93,    94,    95,     0,    96,    97,     0,
       0,     0,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    99,   100,     0,     0,
     101,     0,     0,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   187,     0,   116,
     611,    88,    89,    90,    91,    92,     0,     0,    93,    94,
      95,     0,    96,    97,     0,     0,     0,     0,     0,    98,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,    99,   100,     0,     0,   101,     0,     0,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   732,    88,    89,    90,    91,    92,     0,     0,
      93,    94,    95,     0,    96,    97,   116,     0,     0,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    99,   100,     0,     0,   101,     0,     0,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   784,    88,    89,    90,    91,    92,
       0,     0,    93,    94,    95,     0,    96,    97,     0,     0,
       0,     0,     0,    98,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   116,    99,   100,     0,     0,   101,
       0,     0,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   789,
      88,    89,    90,    91,    92,     0,     0,    93,    94,    95,
       0,    96,    97,     0,     0,     0,     0,     0,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,   101,     0,   116,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   796,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,     0,    96,    97,     0,     0,     0,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,   101,     0,   116,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   840,    88,    89,    90,
      91,    92,   493,     0,    93,    94,    95,     0,    96,    97,
       0,     1,     0,   494,     0,    98,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     0,     0,    99,   100,     0,
       0,   101,     0,   116,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,   116,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,     0,
       0,    49,    50,    51,    52,    53,    54,     0,     0,     0,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,     0,     0,    67,     0,     0,   116,     0,     0,
      68,    69,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      70,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   116,     0,     0,     0,     0,     0,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
       0,     0,     0,     0,     0,     0,     0,    72,     0,     0,
       0,     0,    73,     0,     0,     0,     0,     0,     0,    74,
       0,     0,     0,     0,   116,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     3,     4,     0,     0,    76,     0,    77,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,     0,     0,    80,     0,   116,
       0,     0,     0,     0,    81,    82,    83,     0,     0,     0,
       0,     0,     5,   379,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,     0,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,     0,     0,
      49,    50,    51,    52,    53,    54,   117,     0,     0,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,   423,     0,    67,   424,     0,     0,     0,     0,    68,
      69,     0,   425,     0,     0,   169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    70,
       0,     0,     0,     0,     0,     0,     0,    71,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   426,   427,     0,   428,     0,   429,     0,
     239,   240,   241,   242,   362,   363,     0,     0,   430,   431,
       0,     0,     0,     0,   432,     0,    72,   433,   257,     0,
       0,    73,     0,     0,     0,     0,     0,     0,    74,     0,
       0,     0,     0,     0,    75,     0,   434,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   282,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    76,     0,    77,     0,   435,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,     0,     0,    80,     0,     0,     0,
       0,   619,     0,    81,    82,    83,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   381,
     382,   362,   363,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,     0,     0,     0,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   448
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-761))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       6,     7,    15,    16,    55,    56,    19,    84,     3,    10,
       1,     1,    23,     3,   554,   775,   306,    30,     1,    32,
       3,    12,    12,   741,   742,    38,    39,    40,    12,    12,
       1,     1,    45,    46,    47,    86,   306,     1,    13,     3,
       3,    12,    12,     1,     3,     3,   304,     1,    12,     3,
      63,    64,   592,   593,    12,     1,   304,     3,    12,   304,
       1,   301,   302,    76,    93,   305,    12,     1,    81,    82,
       1,    12,     3,   124,     1,     1,     3,     3,    12,     1,
       1,    12,   107,   108,   109,    12,    12,    12,    13,   304,
      12,    12,   304,     1,   304,     1,     4,    12,    13,     1,
     304,     3,   820,    73,    12,    75,    12,     1,   304,     6,
      12,     8,   304,    10,   308,   128,    99,   100,    12,    44,
     880,    46,    12,    13,   306,    50,    30,    31,    53,    44,
       1,    46,    30,    31,   135,    50,   301,   302,    53,    30,
      31,    12,   107,   108,   109,    99,   100,   306,   289,   290,
     291,   292,   293,   306,    44,   306,    46,   234,   307,   308,
      50,   307,   308,    53,   305,   308,   157,   157,   159,   306,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   306,   154,   155,   156,   157,   307,   308,
     160,    36,    37,   157,   306,   246,   307,   308,     1,   335,
     336,     4,   306,     1,   255,   306,   306,   129,   129,    12,
     151,   152,   153,   306,    12,   228,   306,   125,   126,   127,
     128,   289,   290,   291,   292,   293,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   242,   306,   306,
     256,   157,   306,   159,   306,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   258,   259,
     260,   261,   262,   263,   264,   265,   308,   290,   236,   292,
     305,   304,   308,   154,   218,   304,   220,   221,   304,   302,
     303,   304,   304,     3,   258,   259,   260,   261,   262,   263,
     264,   265,   315,   316,   317,   263,   319,   320,   304,   236,
     304,   324,   325,   326,   327,   305,   306,   263,   304,   122,
     123,   267,   305,   306,   218,   304,   220,   221,   250,   250,
     343,   344,   263,   307,   305,   305,   263,   263,   304,   352,
     353,   354,   306,   356,   357,   306,    13,   305,   306,   362,
     363,   304,   306,   151,   152,   153,    21,    22,    23,   305,
     306,   263,     1,     3,   305,   267,   237,   238,   239,   240,
      13,   305,    12,    12,   305,   306,   304,    12,    12,   306,
     306,   306,   305,   305,   304,    12,    13,   304,   304,   304,
      55,    56,   305,   304,    59,    60,   305,    62,   285,   305,
      65,    23,   307,    68,   306,   308,   419,   307,    73,   308,
       9,     1,   308,   308,   304,   308,   308,    44,    83,    46,
     308,    86,    12,    50,   308,   308,    53,   307,    17,    18,
      19,    20,    21,   306,   305,    24,    25,    26,    27,    28,
      29,    12,   455,    32,    33,    34,    35,    36,    37,   277,
     278,   279,   280,   281,   282,   307,     3,     1,   308,   124,
       3,   474,   475,   476,   477,   308,   307,   304,    12,   269,
     270,   271,   272,   273,   274,   275,   276,   305,     3,   308,
       1,   307,   242,    73,     3,    75,    34,    35,    36,    37,
      23,    12,   505,   506,   507,     3,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   308,
     307,     3,   525,   526,   527,   154,   308,   530,   307,     3,
     269,   270,   271,   272,   273,   274,   275,   276,   308,   307,
     195,   286,   197,   305,   547,   548,   549,   550,   551,   277,
     278,   279,   280,   281,   282,   308,   307,   304,    23,   308,
     215,   307,   565,   566,   567,   568,   305,   307,   571,   307,
     307,   226,   227,   308,   154,   155,   156,   157,   307,   113,
     160,    32,    33,    34,    35,    36,    37,   308,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   308,   113,    23,    23,    38,    39,    40,   237,   238,
     239,   240,    45,    46,    47,    23,    23,   151,   621,    23,
     275,   276,     3,   157,   308,   628,   629,   305,   631,   284,
     882,   883,   884,   885,   886,   887,   639,   640,   307,   307,
     151,   307,   307,   646,   647,   648,   157,   308,    81,    82,
     284,   654,   655,   364,   309,   310,   333,   660,   321,   573,
     516,   328,   293,   449,   469,   668,   486,   297,   323,   672,
      24,    25,    26,    27,    28,    29,   306,   858,    32,    33,
      34,    35,    36,    37,   339,   340,   312,   342,   921,   480,
     531,   633,   347,   656,   641,   305,   370,   649,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   360,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,    -1,    -1,    -1,   307,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   765,    -1,   767,   768,   769,   770,   771,   772,
     773,   305,   775,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,   791,    -1,
      -1,    -1,    -1,    -1,   305,    -1,    -1,    -1,    12,   454,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,   816,    -1,    -1,   857,    12,    -1,    -1,
      -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   836,    -1,    -1,   839,    -1,    -1,    -1,
      -1,   844,    -1,   846,    -1,   848,    -1,   850,    -1,    -1,
      -1,   854,    -1,   508,   509,   858,    -1,    -1,    -1,   862,
      -1,    -1,    -1,    -1,    -1,    -1,   521,    -1,    -1,    -1,
     873,    -1,    -1,   869,    -1,    -1,    -1,   880,    -1,    -1,
     535,   536,   537,   538,   539,    -1,   882,   883,   884,   885,
     886,   887,    21,    22,    23,    -1,    -1,   552,    -1,   113,
     903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   569,   570,    -1,   572,   113,    -1,
      -1,    -1,    -1,    -1,    -1,   921,    55,    56,    -1,    -1,
      59,    60,    -1,    62,    -1,    -1,    65,   151,    -1,    68,
      -1,    -1,    -1,   157,    73,    -1,    -1,    -1,    18,    -1,
      20,    -1,    -1,    -1,    83,    -1,   151,    86,    -1,    29,
      -1,    31,   157,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    42,    -1,    -1,   630,    -1,   632,    48,    -1,
      50,    -1,    52,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   124,    66,    -1,    -1,    -1,
      70,    -1,    72,    -1,   659,    -1,    -1,    -1,    -1,    -1,
     665,    -1,   667,    -1,   669,   670,   671,    -1,   673,   674,
      -1,    -1,    -1,   678,    -1,    -1,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,    -1,    -1,   195,    -1,   197,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,    -1,    -1,
      -1,   305,    17,    18,    19,    20,    21,   226,   227,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    33,    34,
      35,    36,    37,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   275,   276,    24,    25,
      26,    27,    28,    29,    -1,   284,    32,    33,    34,    35,
      36,    37,    -1,   818,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
     309,   310,    -1,    12,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   323,    -1,    24,    25,    26,    27,
      28,    29,   857,    -1,    32,    33,    34,    35,    36,    37,
     339,   340,    -1,   342,    -1,    -1,    -1,    -1,   347,    -1,
      -1,   291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    74,    -1,    76,   318,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    94,    -1,    -1,    97,    -1,
      -1,   341,    -1,    -1,    -1,    -1,   346,    -1,   348,    -1,
      -1,    -1,    -1,    -1,    -1,   355,    -1,   116,   358,   359,
      -1,   361,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    34,    35,   454,    -1,    38,    -1,    -1,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    -1,   478,
      -1,    -1,    -1,    -1,    -1,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   508,
     509,    -1,   307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   521,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   535,   536,   537,   538,
     539,   122,    -1,    -1,   484,    -1,    -1,    17,    18,    19,
      20,    21,    -1,   552,    24,    25,    26,    27,    28,    29,
      -1,   307,    32,    33,    34,    35,    36,    37,    -1,    -1,
     569,   570,    -1,   572,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   305,    -1,    -1,   307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,    -1,
      -1,   630,    -1,   632,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     659,    -1,    -1,    -1,    -1,    -1,   665,    -1,   667,    -1,
     669,   670,   671,    -1,   673,   674,    -1,    -1,    53,   678,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   306,   101,   102,   103,   104,
     105,   106,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,    -1,   124,
      -1,    -1,    -1,    -1,    -1,   130,   131,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    -1,    -1,   150,    22,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    34,    35,
      -1,    -1,    38,    -1,    -1,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   818,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,   217,    22,    -1,    -1,    -1,   222,    -1,    -1,
      -1,    -1,    -1,    -1,   229,    34,    35,    -1,   857,    38,
     235,    -1,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,   133,   134,    -1,
      -1,   266,    -1,   268,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,   283,   284,
      -1,    -1,   287,    22,    -1,    -1,    -1,    -1,    -1,   294,
     295,   296,    -1,    -1,    -1,    34,    35,    -1,   303,    38,
      -1,    -1,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,   133,   134,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      -1,    38,    -1,    -1,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,   133,   134,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,   298,   299,   300,    -1,    -1,    34,    35,   305,
     306,    38,    -1,    -1,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,   298,
     299,   300,    -1,    -1,    34,    35,   305,   306,    38,    -1,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,
     299,   300,    34,    35,    -1,    -1,    38,   306,    -1,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    35,    -1,   304,    38,   306,
      -1,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,
      38,    -1,    -1,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   304,    -1,   306,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    -1,    38,    -1,    -1,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,   306,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    -1,    -1,    38,    -1,    -1,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   306,    34,    35,    -1,    -1,    38,
      -1,    -1,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    35,    -1,    -1,    38,    -1,   306,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    35,    -1,    -1,    38,    -1,   306,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,     1,    -1,    12,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    34,    35,    -1,
      -1,    38,    -1,   306,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,   306,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,   104,   105,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,    -1,   124,    -1,    -1,   306,    -1,    -1,
     130,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,   306,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,   266,    -1,   268,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   283,   284,    -1,    -1,   287,    -1,   306,
      -1,    -1,    -1,    -1,   294,   295,   296,    -1,    -1,    -1,
      -1,    -1,    53,   303,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,   104,   105,   106,     4,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,     1,    -1,   124,     4,    -1,    -1,    -1,    -1,   130,
     131,    -1,    12,    -1,    -1,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    76,    -1,    78,    -1,
      98,    99,   100,   101,   218,   219,    -1,    -1,    88,    89,
      -1,    -1,    -1,    -1,    94,    -1,   217,    97,   116,    -1,
      -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,   229,    -1,
      -1,    -1,    -1,    -1,   235,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   266,    -1,   268,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   283,   284,    -1,    -1,   287,    -1,    -1,    -1,
      -1,   305,    -1,   294,   295,   296,    -1,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,
     238,   218,   219,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    12,    13,    14,    53,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,   101,
     102,   103,   104,   105,   106,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   124,   130,   131,
     150,   158,   217,   222,   229,   235,   266,   268,   283,   284,
     287,   294,   295,   296,   310,   312,    23,     3,     4,     5,
       6,     7,     8,    11,    12,    13,    15,    16,    22,    34,
      35,    38,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,   306,   329,   330,   331,
     332,   333,   334,   335,   306,    12,   334,   334,   306,     3,
       3,    13,   338,   327,   329,   390,   327,   391,   327,     1,
       4,    12,   122,   123,   394,   390,   327,   392,   390,   333,
     335,   335,   306,   314,   335,   336,   337,   315,   316,   317,
     304,   313,   390,   327,   390,   122,   327,     3,   328,   329,
     390,   392,   392,   392,   390,   390,   319,   320,   392,   392,
     304,   392,   390,   304,   324,   390,   304,   304,   390,   390,
     304,   336,   336,   321,   322,   304,   335,   304,   335,   304,
     335,   327,   327,   335,   390,     1,     4,    12,   125,   126,
     127,   128,   395,   335,    10,   135,   390,   304,   390,   335,
     323,    93,   325,   327,   393,   326,   304,   304,   304,   392,
     392,   335,     0,   303,   311,   312,   336,   306,   306,   329,
     329,   329,   329,   306,   306,   306,   306,   306,   306,   306,
     306,   306,   306,   306,   306,   306,   306,   329,    17,    18,
      19,    20,    21,    24,    25,    26,    27,    28,    29,    32,
      33,    34,    35,    36,    37,    30,    31,   336,   327,   308,
     308,   308,   329,   304,   308,   304,   304,   304,     1,    12,
     218,   220,   221,   351,   352,   304,     3,   304,   304,     1,
       3,    12,    99,   100,   306,   386,   387,     1,    12,   151,
     152,   153,   371,   372,   304,   277,   278,   279,   280,   281,
     282,   345,   346,   289,   290,   291,   292,   293,   347,   348,
     107,   108,   109,   341,   342,   304,   304,   335,   335,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   218,   219,   339,   340,   318,   335,   301,   302,
     396,   397,   304,   304,   304,   304,   335,   335,   327,   303,
     312,   329,   329,   335,   335,   335,   336,   335,   335,   335,
     335,   335,   335,   335,   335,   336,   334,   307,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   335,   335,   307,   307,   306,
      13,    13,   307,     1,     4,    12,    73,    74,    76,    78,
      88,    89,    94,    97,   116,   149,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   288,   353,
     354,   337,     1,    12,   157,   159,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   355,
     356,     1,    12,    73,    75,   154,   155,   156,   157,   160,
     373,   374,     1,    12,   129,   250,   357,   358,   327,   390,
     327,   305,   352,     1,    12,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   349,   350,     1,     3,
      12,   157,   258,   259,   260,   261,   262,   263,   264,   265,
     306,   380,   381,     1,    12,   113,   151,   157,   240,   241,
     243,   244,   245,   246,   247,   248,   249,   251,   252,   253,
     254,   255,   256,   257,   378,   379,   327,   327,   327,   305,
     387,   335,   335,   305,   372,   269,   270,   271,   272,   273,
     274,   275,   276,   343,   344,   327,   327,   327,   390,   327,
     327,   305,   346,   335,   327,   327,   327,   327,   305,   348,
     305,   342,   378,   378,   305,   305,   335,   335,   390,   335,
     327,   327,   390,   335,   390,   327,     3,   327,   327,   390,
     327,     3,   327,   390,   390,   335,   390,   327,   327,   305,
     340,   304,    12,    12,   305,   397,     1,    12,   154,   237,
     238,   239,   240,   375,   376,     1,     3,    12,   236,   263,
     306,   382,   383,     1,     3,    12,   263,   267,   306,   384,
     385,     1,     3,    12,   263,   306,   388,   389,   305,   285,
      23,   307,   307,   307,   307,   308,   307,   308,   308,   308,
     308,   308,   308,   308,   308,   307,   307,   327,   306,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   305,   354,   335,   327,   305,   356,   327,   327,
     327,   327,   335,   305,   374,   390,     6,     8,    10,   305,
     358,     9,   327,   327,   327,   335,   335,   305,   350,   335,
     327,   327,     3,   327,   327,   305,   381,   335,   335,   335,
     335,   335,    12,   327,   327,   327,   327,   327,   335,   305,
     379,   307,   327,   327,   327,   327,   335,   335,   327,   335,
     305,   344,   305,   305,     3,   308,     3,   308,   132,   133,
     134,   298,   299,   300,   327,   360,   361,   327,   327,   335,
     327,   335,   305,   376,     3,   327,   327,   305,   383,     3,
     327,   263,   327,   327,   305,   385,     3,   327,   327,   305,
     389,   335,   327,   335,   335,   327,   335,   335,   335,   327,
     335,   335,   307,   335,   359,     3,   308,   307,   242,   377,
       3,   377,   377,   327,     3,   327,   327,   327,   327,   327,
     327,   327,    23,   305,   361,     3,   308,   307,     3,   308,
       3,   327,   307,     3,   308,   307,   286,   305,   308,   307,
     308,   307,   307,   307,   308,   307,   307,   308,   304,   327,
     335,   377,   308,    23,    23,    23,    23,    23,    23,   365,
     327,   327,     3,   308,   327,   327,   327,   327,   327,   336,
     360,   327,   366,   367,   368,   363,   362,   364,     3,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   297,   306,   334,   369,   370,   327,   305,   307,
     307,   307,   307,   305,   369,   369,   369,   369,   369,   369,
     327,   308,   307,   370
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:

/* Line 1806 of yacc.c  */
#line 368 "parser.y"
    {}
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 370 "parser.y"
    { config.hogthreshold = (yyvsp[(2) - (2)].i_value); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 371 "parser.y"
    { IFCLASS(CL_VAR){ define_config_variable((yyvsp[(2) - (2)].s_value));} free((yyvsp[(2) - (2)].s_value)); }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 372 "parser.y"
    { IFCLASS(CL_VAR){ undefine_config_variable((yyvsp[(2) - (2)].s_value));} free((yyvsp[(2) - (2)].s_value)); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 373 "parser.y"
    {
			/* NOTE:
			 * We _need_ absolutely to return to state stack 0
			 * because we 'backward' modify the input stream for
			 * the parser (in lexer). Hence, _if_ the parser needs
			 * to read one token more than needed, we are lost,
			 * because we can't discard it. So please, don't
			 * play with the grammar without knowing what you do.
			 * The ')' _will_ return to state stack 0, but fiddling
			 * with brackets '()' in the underlaying 'expression'
			 * rules may distroy this.
			 *                          -- Hans 971231
			 */
			tell_lexer_if((yyvsp[(3) - (4)].i_value));
		}
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 395 "parser.y"
    {
			tell_lexer_loop((yyvsp[(2) - (6)].i_value), (yyvsp[(5) - (6)].i_value));
		}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 398 "parser.y"
    {
			tell_lexer_loop((yyvsp[(2) - (9)].i_value), for_each_handling((yyvsp[(2) - (9)].i_value),(yyvsp[(4) - (9)].s_value),(yyvsp[(6) - (9)].s_value),(yyvsp[(8) - (9)].s_value)));
			free((yyvsp[(4) - (9)].s_value)); free((yyvsp[(6) - (9)].s_value)); free((yyvsp[(8) - (9)].s_value));
		}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 402 "parser.y"
    {
			char *s = run_shell((yyvsp[(3) - (4)].s_value));
			if (s) free(s);
			free((yyvsp[(3) - (4)].s_value));
		}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 407 "parser.y"
    { enter_user_scope((yyvsp[(1) - (1)].i_value)); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 408 "parser.y"
    { leave_user_scope((yyvsp[(1) - (1)].i_value)); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 409 "parser.y"
    {
		    if (!parser_version_3_style_used) {
			parser_version_3_style_used = 1;
			define_config_variable(CONFNAME_V3USED);
		    }
		    if ((strpbrk((yyvsp[(1) - (3)].s_value), "uhc") == (yyvsp[(1) - (3)].s_value)) && ((yyvsp[(1) - (3)].s_value)[1] == '_'))
			yyerror("reserved variable %s can't be set\n", (yyvsp[(1) - (3)].s_value));
		    else {
			if (user_scope_level) {
			    char *s = malloc(strlen((yyvsp[(1) - (3)].s_value))+sizeof(USERVAR_PREF));
			    strcpy(s, USERVAR_PREF);
			    strcat(s,(yyvsp[(1) - (3)].s_value));
			    setenv(s, (yyvsp[(3) - (3)].s_value), 1);
			    free(s);
			}
			else IFCLASS(CL_VAR) setenv((yyvsp[(1) - (3)].s_value), (yyvsp[(3) - (3)].s_value), 1);
		    }
		    free((yyvsp[(1) - (3)].s_value)); free((yyvsp[(3) - (3)].s_value));
		}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 429 "parser.y"
    {
		    if ((yyvsp[(2) - (2)].t_value).type == TYPE_REAL)
			c_printf("CONF TESTING: exprtest real %f\n", (yyvsp[(2) - (2)].t_value).value.r);
		    else
			c_printf("CONF TESTING: exprtest int %d\n", (yyvsp[(2) - (2)].t_value).value.i);
		}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 440 "parser.y"
    { if ((yyvsp[(2) - (2)].s_value)[0]) fprintf(stderr,"CONF aborted with: %s\n", (yyvsp[(2) - (2)].s_value));
			exit(99);
		    }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 443 "parser.y"
    { c_printf("CONF: %s\n", (yyvsp[(2) - (2)].s_value)); free((yyvsp[(2) - (2)].s_value)); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 445 "parser.y"
    {
		    free(config.emusys); config.emusys = (yyvsp[(2) - (2)].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[(2) - (2)].s_value));
		    }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 450 "parser.y"
    {
		    free(config.emusys); config.emusys = (yyvsp[(3) - (4)].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[(3) - (4)].s_value));
		    }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 455 "parser.y"
    {
#ifdef USE_MHPDBG
		    free(DOSEMU_MAP_PATH); DOSEMU_MAP_PATH = (yyvsp[(2) - (2)].s_value);
		    c_printf("CONF: dosemu.map path = '%s'\n", (yyvsp[(2) - (2)].s_value));
#else
		    free((yyvsp[(2) - (2)].s_value));
#endif
		    }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 464 "parser.y"
    {
		    free(config.mappingdriver); config.mappingdriver = (yyvsp[(2) - (2)].s_value);
		    c_printf("CONF: mapping driver = '%s'\n", (yyvsp[(2) - (2)].s_value));
		    }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 469 "parser.y"
    {
                    free(config.emuini); config.emuini = (yyvsp[(2) - (2)].s_value);
                    c_printf("CONF: config.emuini = '%s'\n", (yyvsp[(2) - (2)].s_value));
                    }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 474 "parser.y"
    {
                    free(config.emuini); config.emuini = (yyvsp[(3) - (4)].s_value);
                    c_printf("CONF: config.emuini = '%s'\n", (yyvsp[(3) - (4)].s_value));
		    }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 479 "parser.y"
    {
		    config.full_file_locks = ((yyvsp[(2) - (2)].i_value)!=0);
		    }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 483 "parser.y"
    {
		    config.lfn = ((yyvsp[(2) - (2)].i_value)!=0);
		    }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 487 "parser.y"
    {
			config.fastfloppy = ((yyvsp[(2) - (2)].i_value)!=0);
			c_printf("CONF: fastfloppy = %d\n", config.fastfloppy);
			}
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 492 "parser.y"
    {
			int cpu = cpu_override (((yyvsp[(2) - (2)].i_value)%100)==86?((yyvsp[(2) - (2)].i_value)/100)%10:0);
			if (cpu > 0) {
				c_printf("CONF: CPU set to %d86\n",cpu);
				vm86s.cpu_type = cpu;
			}
			else
				yyerror("error in CPU user override\n");
			}
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 502 "parser.y"
    {
			vm86s.cpu_type = 5;
#ifdef X86_EMULATOR
			config.cpuemu = 1;
			c_printf("CONF: CPUEMU set to %d for %d86\n",
				config.cpuemu, vm86s.cpu_type);
#endif
			}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 511 "parser.y"
    {
#ifdef X86_EMULATOR
			config.cpuemu = (yyvsp[(2) - (2)].i_value);
			if (config.cpuemu > 4) {
				config.cpuemu -= 2;
#ifdef HOST_ARCH_X86
				config.cpusim = 1;
#endif
			}
			c_printf("CONF: %s CPUEMU set to %d for %d86\n",
				CONFIG_CPUSIM ? "simulated" : "JIT",
				config.cpuemu, vm86s.cpu_type);
#endif
			}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 526 "parser.y"
    { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = ((double)LLF_US)/(yyvsp[(2) - (2)].r_value);
			  config.cpu_tick_spd = ((double)LLF_TICKS)/(yyvsp[(2) - (2)].r_value);
			  c_printf("CONF: CPU speed = %g\n", ((double)(yyvsp[(2) - (2)].r_value)));
			}
#endif
			}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 536 "parser.y"
    { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = (LLF_US*(yyvsp[(3) - (3)].i_value))/(yyvsp[(2) - (3)].i_value);
			  config.cpu_tick_spd = (LLF_TICKS*(yyvsp[(3) - (3)].i_value))/(yyvsp[(2) - (3)].i_value);
			  c_printf("CONF: CPU speed = %d/%d\n", (yyvsp[(2) - (3)].i_value), (yyvsp[(3) - (3)].i_value));
			}
#endif
			}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 546 "parser.y"
    {
			config.rdtsc = ((yyvsp[(2) - (2)].i_value)!=0);
			c_printf("CONF: %sabling use of pentium timer\n",
				(config.rdtsc?"En":"Dis"));
		    }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 552 "parser.y"
    { 
		      config.pci_video = ((yyvsp[(2) - (2)].i_value)!=0);
		      IFCLASS(CL_PCI);
		      config.pci = (abs((yyvsp[(2) - (2)].i_value))==2); 
		    }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 558 "parser.y"
    {
		      config.hdiskboot = 0;
		    }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 562 "parser.y"
    {
		      config.hdiskboot = 1;
		    }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 566 "parser.y"
    {
		      config.hdiskboot = 2;
		    }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 570 "parser.y"
    {
		    config.freq = (yyvsp[(2) - (2)].i_value);
		    if ((yyvsp[(2) - (2)].i_value)) {
		        config.update = 1000000 / (yyvsp[(2) - (2)].i_value);
		    } else {
			config.update = 54925;
			config.freq = 18;
		    }
		    c_printf("CONF: timer freq=%d, update=%d\n",config.freq,config.update);
		    }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 581 "parser.y"
    {
		      char *b;
		      flush_log();
		      b = malloc((yyvsp[(2) - (2)].i_value)+1024);
		      if (!b) {
			error("cannot get logbuffer\n");
			exit(1);
		      }
		      logptr = logbuf = b;
		      logbuf_size = (yyvsp[(2) - (2)].i_value);
		    }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 593 "parser.y"
    {
		      logfile_limit = (yyvsp[(2) - (2)].i_value);
		    }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 597 "parser.y"
    {
		    config.dosbanner = ((yyvsp[(2) - (2)].i_value)!=0);
		    c_printf("CONF: dosbanner %s\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off");
		    }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 602 "parser.y"
    { IFCLASS(CL_VPORT){
		    if ((yyvsp[(2) - (2)].i_value) && !config.emuretrace && priv_lvl)
		      yyerror("Can not modify video port access in user config file");
		    config.emuretrace = ((yyvsp[(2) - (2)].i_value)!=0);
		    c_printf("CONF: emu_retrace %s\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off");
		    }}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 610 "parser.y"
    {
		    if ((yyvsp[(2) - (2)].i_value) >= 0) config.ems_size = (yyvsp[(2) - (2)].i_value);
		    if ((yyvsp[(2) - (2)].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[(2) - (2)].i_value));
		    }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 615 "parser.y"
    {
		    if ((yyvsp[(2) - (2)].i_value) >= 0) config.xms_size = (yyvsp[(2) - (2)].i_value);
		    if ((yyvsp[(2) - (2)].i_value) > 0) c_printf("CONF: %dk bytes XMS memory\n", (yyvsp[(2) - (2)].i_value));
		    }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 620 "parser.y"
    {
		    config.max_umb = ((yyvsp[(2) - (2)].i_value)!=0);
		    if ((yyvsp[(2) - (2)].i_value) > 0) c_printf("CONF: maximize umb's %s\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off");
		    }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 625 "parser.y"
    {
		    if ((yyvsp[(2) - (2)].i_value)>=0) config.dpmi = (yyvsp[(2) - (2)].i_value);
		    c_printf("CONF: DPMI-Server %s (%#x)\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off", ((yyvsp[(2) - (2)].i_value)));
		    }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 630 "parser.y"
    {
		    config.dpmi_base = (yyvsp[(2) - (2)].i_value);
		    c_printf("CONF: DPMI base addr = %#x\n", (yyvsp[(2) - (2)].i_value));
		    }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 635 "parser.y"
    {
		    config.pm_dos_api = ((yyvsp[(2) - (2)].i_value)!=0);
		    c_printf("CONF: PM DOS API Translator %s\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off");
		    }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 640 "parser.y"
    {
		    config.no_null_checks = ((yyvsp[(2) - (2)].i_value)!=0);
		    c_printf("CONF: No DJGPP NULL deref checks: %s\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off");
		    }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 644 "parser.y"
    { if ((yyvsp[(2) - (2)].i_value)>=0) config.mem_size = (yyvsp[(2) - (2)].i_value); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 645 "parser.y"
    { if ((yyvsp[(2) - (2)].i_value)>=0) config.ext_mem = (yyvsp[(2) - (2)].i_value); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 646 "parser.y"
    { config.mathco = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 648 "parser.y"
    {
		    config.ipxsup = ((yyvsp[(2) - (2)].i_value)!=0);
		    c_printf("CONF: IPX support %s\n", ((yyvsp[(2) - (2)].i_value)) ? "on" : "off");
		    }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 652 "parser.y"
    { config.ipx_net = (yyvsp[(2) - (2)].i_value); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 654 "parser.y"
    {
		      if (config.vnet == VNET_TYPE_TAP || (yyvsp[(2) - (2)].i_value) == 0 || is_in_allowed_classes(CL_NET)) {
			config.pktdrv = ((yyvsp[(2) - (2)].i_value)!=0);
			c_printf("CONF: Packet Driver %s.\n", 
				((yyvsp[(2) - (2)].i_value)) ? "enabled" : "disabled");
		      }
		    }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 661 "parser.y"
    { free(config.netdev); config.netdev = (yyvsp[(2) - (2)].s_value); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 662 "parser.y"
    { config.pktflags = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 663 "parser.y"
    { start_vnet((yyvsp[(2) - (2)].s_value)); free((yyvsp[(2) - (2)].s_value)); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 665 "parser.y"
    {
		    if ((yyvsp[(2) - (2)].i_value) == SPKR_NATIVE) {
		      if (can_do_root_stuff) {
                        c_printf("CONF: allowing speaker port access!\n");
		      } else {
                        c_printf("CONF: native speaker not allowed: emulate\n");
			(yyvsp[(2) - (2)].i_value) = SPKR_EMULATED;
		      }
		    }
		    else
                      c_printf("CONF: not allowing speaker port access\n");
		    config.speaker = (yyvsp[(2) - (2)].i_value);
		    }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 679 "parser.y"
    { start_video(); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 681 "parser.y"
    { stop_video(); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 682 "parser.y"
    { free(config.xterm_title); config.xterm_title = (yyvsp[(2) - (2)].s_value); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 685 "parser.y"
    { stop_terminal(); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 686 "parser.y"
    {
			parse_debugflags((yyvsp[(2) - (2)].s_value), 1);
			free((yyvsp[(2) - (2)].s_value));
		}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 691 "parser.y"
    { start_debug(); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 694 "parser.y"
    { start_mouse(); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 696 "parser.y"
    { stop_mouse(); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 699 "parser.y"
    { stop_ttylocks(); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 701 "parser.y"
    { start_serial(); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 703 "parser.y"
    { stop_serial(); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 705 "parser.y"
    { start_keyboard(); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 708 "parser.y"
    {keytable_start((yyvsp[(2) - (2)].i_value));}
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 710 "parser.y"
    {keytable_stop();}
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 712 "parser.y"
    {
		    append_pre_strokes((yyvsp[(2) - (2)].s_value));
		    c_printf("CONF: appending pre-strokes '%s'\n", (yyvsp[(2) - (2)].s_value));
		    free((yyvsp[(2) - (2)].s_value));
		    }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 717 "parser.y"
    {
			dump_keytables_to_file((yyvsp[(3) - (3)].s_value));
			free((yyvsp[(3) - (3)].s_value));
		    }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 722 "parser.y"
    { IFCLASS(CL_PORT) start_ports(); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 726 "parser.y"
    { start_disk(); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 728 "parser.y"
    { stop_disk(DISK); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 730 "parser.y"
    { start_bootdisk(); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 732 "parser.y"
    { stop_disk(BOOTDISK); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 734 "parser.y"
    { start_floppy(); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 736 "parser.y"
    { stop_disk(L_FLOPPY); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 738 "parser.y"
    {
		    static int which = 0;
		    if (which >= 3) {
			c_printf("CONF: too many cdrom drives defined\n");
			free((yyvsp[(3) - (4)].s_value));
		    }
		    else {
			Path_cdrom[which] = (yyvsp[(3) - (4)].s_value);
			c_printf("CONF: cdrom MSCD000%d on %s\n", which+1 ,(yyvsp[(3) - (4)].s_value));
			which++;
		    }
		    }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 751 "parser.y"
    {
#ifdef ASPI_SUPPORT
		    char *s = aspi_add_device((yyvsp[(3) - (8)].s_value), (yyvsp[(5) - (8)].s_value), (yyvsp[(7) - (8)].i_value));
		    if (s) {
			c_printf("CONF: aspi available for %s\n", s);
			free(s);
		    }
		    else c_printf("CONF: aspi device %s not available\n", (yyvsp[(3) - (8)].s_value));
#endif
		    free((yyvsp[(3) - (8)].s_value));
		    free((yyvsp[(5) - (8)].s_value));
		    }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 764 "parser.y"
    { start_printer(); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 766 "parser.y"
    { stop_printer(); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 768 "parser.y"
    { config.sound = (yyvsp[(2) - (2)].i_value)==2 ? 2 : (yyvsp[(2) - (2)].i_value)==0 ? 0 : 1; }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 769 "parser.y"
    { config.sound = 1; }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 771 "parser.y"
    { if (! (yyvsp[(2) - (2)].i_value)) { config.joy_device[0] = config.joy_device[1] = NULL; } }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 774 "parser.y"
    { IFCLASS(CL_IRQ) config.sillyint=0; }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 777 "parser.y"
    { IFCLASS(CL_IRQ) if ((yyvsp[(2) - (2)].i_value)) {
		        config.sillyint = 1 << (yyvsp[(2) - (2)].i_value);
		        c_printf("CONF: IRQ %d for irqpassing\n", (yyvsp[(2) - (2)].i_value));
		      }
		    }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 784 "parser.y"
    { IFCLASS(CL_HARDRAM);
		    if (priv_lvl)
		      yyerror("Can not change hardware ram access settings in user config file");
		    }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 790 "parser.y"
    {
			handle_features((yyvsp[(3) - (6)].i_value), (yyvsp[(5) - (6)].i_value));
		    }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 794 "parser.y"
    { config.cli_timeout = (yyvsp[(2) - (2)].i_value); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 796 "parser.y"
    { config.pic_watchdog = (yyvsp[(2) - (2)].i_value); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 798 "parser.y"
    {
		    config.timemode = parse_timemode((yyvsp[(2) - (2)].s_value));
		    c_printf("CONF: time mode = '%s'\n", (yyvsp[(2) - (2)].s_value));
		    free((yyvsp[(2) - (2)].s_value));
		    }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 804 "parser.y"
    { yyerror("unrecognized command '%s'", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 808 "parser.y"
    { (yyval.i_value) = TOF((yyvsp[(1) - (1)].t_value)); }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 811 "parser.y"
    { (yyval.r_value) = TOF((yyvsp[(1) - (1)].t_value)); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 816 "parser.y"
    {(yyval.t_value).type = TYPE_INTEGER; (yyval.t_value).value.i=(yyvsp[(1) - (1)].i_value);}
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 817 "parser.y"
    {(yyval.t_value).type = TYPE_BOOLEAN; (yyval.t_value).value.i=(yyvsp[(1) - (1)].i_value);}
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 818 "parser.y"
    {(yyval.t_value).type = TYPE_REAL; (yyval.t_value).value.r=(yyvsp[(1) - (1)].r_value);}
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 820 "parser.y"
    {V_VAL((yyval.t_value),(yyvsp[(1) - (3)].t_value),TOF((yyvsp[(1) - (3)].t_value)) + TOF((yyvsp[(3) - (3)].t_value))); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 822 "parser.y"
    {V_VAL((yyval.t_value),(yyvsp[(1) - (3)].t_value),TOF((yyvsp[(1) - (3)].t_value)) - TOF((yyvsp[(3) - (3)].t_value))); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 824 "parser.y"
    {V_VAL((yyval.t_value),(yyvsp[(1) - (3)].t_value),TOF((yyvsp[(1) - (3)].t_value)) * TOF((yyvsp[(3) - (3)].t_value))); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 825 "parser.y"
    {
			if (TOF((yyvsp[(3) - (3)].t_value)))	V_VAL((yyval.t_value),(yyvsp[(1) - (3)].t_value),TOF((yyvsp[(1) - (3)].t_value)) / TOF((yyvsp[(3) - (3)].t_value)));
			else V_VAL((yyval.t_value),(yyvsp[(1) - (3)].t_value),TOF((yyvsp[(3) - (3)].t_value)));
		}
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 830 "parser.y"
    {V_VAL((yyval.t_value),(yyvsp[(2) - (2)].t_value),-TOF((yyvsp[(2) - (2)].t_value))); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 832 "parser.y"
    {V_VAL((yyval.t_value),(yyvsp[(2) - (2)].t_value),TOF((yyvsp[(2) - (2)].t_value))); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 834 "parser.y"
    { unsigned int shift = (1 << (int)TOF((yyvsp[(3) - (3)].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[(1) - (3)].t_value);
			else V_VAL((yyval.t_value), (yyvsp[(1) - (3)].t_value), TOF((yyvsp[(1) - (3)].t_value)) / shift);}
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 838 "parser.y"
    { unsigned int shift = (1 << (int)TOF((yyvsp[(3) - (3)].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[(1) - (3)].t_value);
			else V_VAL((yyval.t_value), (yyvsp[(1) - (3)].t_value), TOF((yyvsp[(1) - (3)].t_value)) * shift);}
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 841 "parser.y"
    {
			char *s;
			(yyval.t_value).type = TYPE_INTEGER;
			(yyval.t_value).value.i = strtoul((yyvsp[(1) - (1)].s_value),&s,0);
			switch (*s) {
				case '.':  case 'e':  case 'E':
				/* we assume a real number */
				(yyval.t_value).type = TYPE_REAL;
				(yyval.t_value).value.r = strtod((yyvsp[(1) - (1)].s_value),0);
			}
			free((yyvsp[(1) - (1)].s_value));
		}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 853 "parser.y"
    {(yyval.t_value) = (yyvsp[(2) - (3)].t_value);}
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 858 "parser.y"
    {(yyval.i_value) = (int)TOF((yyvsp[(1) - (3)].t_value)) & (int)TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 860 "parser.y"
    {(yyval.i_value) = (int)TOF((yyvsp[(1) - (3)].t_value)) | (int)TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 862 "parser.y"
    {(yyval.i_value) = (int)TOF((yyvsp[(1) - (3)].t_value)) ^ (int)TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 864 "parser.y"
    {(yyval.i_value) = (int)TOF((yyvsp[(2) - (2)].t_value)) ^ (-1); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 865 "parser.y"
    {(yyval.i_value) = -1; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 866 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(3) - (4)].t_value));}
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 867 "parser.y"
    {
			(yyval.i_value) = strtol((yyvsp[(3) - (4)].s_value),0,0);
			free((yyvsp[(3) - (4)].s_value));
		}
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 871 "parser.y"
    {
			(yyval.i_value) = strlen((yyvsp[(3) - (4)].s_value));
			free((yyvsp[(3) - (4)].s_value));
		}
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 875 "parser.y"
    {
			(yyval.i_value) = strncmp((yyvsp[(3) - (8)].s_value),(yyvsp[(5) - (8)].s_value),(yyvsp[(7) - (8)].i_value));
			free((yyvsp[(3) - (8)].s_value)); free((yyvsp[(5) - (8)].s_value));
		}
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 879 "parser.y"
    {
			char *s = strpbrk((yyvsp[(3) - (6)].s_value),(yyvsp[(5) - (6)].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[(3) - (6)].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[(3) - (6)].s_value)); free((yyvsp[(5) - (6)].s_value));
		}
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 885 "parser.y"
    {
			char *s = strchr((yyvsp[(3) - (6)].s_value),(yyvsp[(5) - (6)].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[(3) - (6)].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[(3) - (6)].s_value)); free((yyvsp[(5) - (6)].s_value));
		}
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 891 "parser.y"
    {
			char *s = strrchr((yyvsp[(3) - (6)].s_value),(yyvsp[(5) - (6)].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[(3) - (6)].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[(3) - (6)].s_value)); free((yyvsp[(5) - (6)].s_value));
		}
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 897 "parser.y"
    {
			char *s = strstr((yyvsp[(3) - (6)].s_value),(yyvsp[(5) - (6)].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[(3) - (6)].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[(3) - (6)].s_value)); free((yyvsp[(5) - (6)].s_value));
		}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 903 "parser.y"
    {
			(yyval.i_value) = strspn((yyvsp[(3) - (6)].s_value),(yyvsp[(5) - (6)].s_value));
			free((yyvsp[(3) - (6)].s_value)); free((yyvsp[(5) - (6)].s_value));
		}
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 907 "parser.y"
    {
			(yyval.i_value) = strcspn((yyvsp[(3) - (6)].s_value),(yyvsp[(5) - (6)].s_value));
			free((yyvsp[(3) - (6)].s_value)); free((yyvsp[(5) - (6)].s_value));
		}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 911 "parser.y"
    {
			if ( (yyvsp[(1) - (1)].s_value)[0] == '\'' && (yyvsp[(1) - (1)].s_value)[1] && (yyvsp[(1) - (1)].s_value)[2] == '\'' && !(yyvsp[(1) - (1)].s_value)[3] )
				(yyval.i_value) = (yyvsp[(1) - (1)].s_value)[1];
			else	yyerror("unrecognized expression '%s'", (yyvsp[(1) - (1)].s_value));
			free((yyvsp[(1) - (1)].s_value));
		}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 920 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) == TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 922 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) != TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 924 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) >= TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 926 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) <= TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 928 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) < TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 930 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) > TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 932 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) && TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 934 "parser.y"
    {(yyval.i_value) = TOF((yyvsp[(1) - (3)].t_value)) || TOF((yyvsp[(3) - (3)].t_value)); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 936 "parser.y"
    {(yyval.i_value) = strcmp((yyvsp[(1) - (3)].s_value),(yyvsp[(3) - (3)].s_value)) == 0; free((yyvsp[(1) - (3)].s_value)); free((yyvsp[(3) - (3)].s_value)); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 938 "parser.y"
    {(yyval.i_value) = strcmp((yyvsp[(1) - (3)].s_value),(yyvsp[(3) - (3)].s_value)) != 0; free((yyvsp[(1) - (3)].s_value)); free((yyvsp[(3) - (3)].s_value)); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 939 "parser.y"
    {(yyval.i_value) = (TOF((yyvsp[(2) - (2)].t_value)) ? 0:1); }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 940 "parser.y"
    {(yyval.i_value) = -2; }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 941 "parser.y"
    {(yyval.i_value) = 0; }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 942 "parser.y"
    {(yyval.i_value) = -2; }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 943 "parser.y"
    {(yyval.i_value) = 0; }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 944 "parser.y"
    {
			(yyval.i_value) = get_config_variable((yyvsp[(3) - (4)].s_value)) !=0;
			free((yyvsp[(3) - (4)].s_value));
		}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 951 "parser.y"
    {(yyval.r_value) = TOF((yyvsp[(3) - (4)].t_value));}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 955 "parser.y"
    {
			char *s = (yyvsp[(1) - (1)].s_value);
			if (get_config_variable(s))
				s = "1";
			else if (strncmp("c_",s,2)
					&& strncmp("u_",s,2)
					&& strncmp("h_",s,2) ) {
				s = checked_getenv(s);
				if (!s) s = "";
			}
			else
				s = "0";
			(yyval.s_value) = strdup(s);
			free((yyvsp[(1) - (1)].s_value));
		}
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 972 "parser.y"
    {
			(yyval.s_value) = (yyvsp[(1) - (1)].s_value);
			if ((yyval.s_value)[0] == '\'' || (yyval.s_value)[0] == '\"') {
				size_t len = strlen((yyvsp[(1) - (1)].s_value)) - 2;
				memmove((yyval.s_value), (yyval.s_value)+1, len);
				(yyval.s_value)[len] = '\0';
			}
		}
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 983 "parser.y"
    {(yyval.s_value) = (yyvsp[(3) - (4)].s_value); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 984 "parser.y"
    {
			int i = (yyvsp[(5) - (8)].i_value);
			int len = (yyvsp[(7) - (8)].i_value);
			int slen = strlen((yyvsp[(3) - (8)].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) len = slen - i;
				(yyvsp[(3) - (8)].s_value)[i+len] = 0;
				(yyval.s_value) = strdup((yyvsp[(3) - (8)].s_value) + i);
			}
			else
				(yyval.s_value) = strdup("");
			free((yyvsp[(3) - (8)].s_value));
		}
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 997 "parser.y"
    {
			int i = (yyvsp[(5) - (8)].i_value);
			int len = (yyvsp[(7) - (8)].i_value);
			int slen = strlen((yyvsp[(3) - (8)].s_value));
			char *s = strdup((yyvsp[(3) - (8)].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) s[i] = 0;
				else memmove(s+i, s+i+len, slen-i-len+1);
			}
			free((yyvsp[(3) - (8)].s_value));
			(yyval.s_value) = s;
		}
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1009 "parser.y"
    {
			(yyval.s_value) = run_shell((yyvsp[(3) - (4)].s_value));
			free((yyvsp[(3) - (4)].s_value));
		}
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1013 "parser.y"
    {(yyval.s_value) = (yyvsp[(1) - (1)].s_value);}
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1017 "parser.y"
    {
			char *s = malloc(strlen((yyvsp[(1) - (3)].s_value))+strlen((yyvsp[(3) - (3)].s_value))+1);
			strcpy(s, (yyvsp[(1) - (3)].s_value));
			strcat(s, (yyvsp[(3) - (3)].s_value));
			(yyval.s_value) = s;
			free((yyvsp[(1) - (3)].s_value)); free((yyvsp[(3) - (3)].s_value));
		}
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1027 "parser.y"
    {
			if ((yyvsp[(2) - (3)].t_value).type == TYPE_REAL)
				asprintf(&(yyval.s_value), "%g", (yyvsp[(2) - (3)].t_value).value.r);
			else
				asprintf(&(yyval.s_value), "%d", (yyvsp[(2) - (3)].t_value).value.i);
		}
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1036 "parser.y"
    {
			check_user_var((yyvsp[(1) - (1)].s_value));
			free((yyvsp[(1) - (1)].s_value));
		}
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1040 "parser.y"
    {
			check_user_var((yyvsp[(3) - (3)].s_value));
			free((yyvsp[(3) - (3)].s_value));
		}
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1051 "parser.y"
    { config.X_updatelines = (yyvsp[(2) - (2)].i_value); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1052 "parser.y"
    { config.X_updatefreq = (yyvsp[(2) - (2)].i_value); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1053 "parser.y"
    { free(config.X_display); config.X_display = (yyvsp[(2) - (2)].s_value); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1054 "parser.y"
    { free(config.X_title); config.X_title = (yyvsp[(2) - (2)].s_value); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1055 "parser.y"
    { config.X_title_show_appname = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1056 "parser.y"
    { free(config.X_icon_name); config.X_icon_name = (yyvsp[(2) - (2)].s_value); }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1057 "parser.y"
    { config.X_keycode = (yyvsp[(2) - (2)].i_value); }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1058 "parser.y"
    { config.X_blinkrate = (yyvsp[(2) - (2)].i_value); }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1059 "parser.y"
    { config.X_sharecmap = 1; }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1060 "parser.y"
    { config.X_mitshm = 1; }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1061 "parser.y"
    { config.X_mitshm = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1062 "parser.y"
    { free(config.X_font); config.X_font = (yyvsp[(2) - (2)].s_value); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1063 "parser.y"
    { config.X_fixed_aspect = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1064 "parser.y"
    { config.X_aspect_43 = 1; }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1065 "parser.y"
    { config.X_lin_filt = 1; }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1066 "parser.y"
    { config.X_bilin_filt = 1; }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1067 "parser.y"
    { config.X_mode13fact = (yyvsp[(2) - (2)].i_value); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1069 "parser.y"
    {
                     config.X_winsize_x = (yyvsp[(2) - (3)].i_value);
                     config.X_winsize_y = (yyvsp[(3) - (3)].i_value);
                   }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1074 "parser.y"
    {
                     config.X_winsize_x = (yyvsp[(2) - (4)].i_value);
                     config.X_winsize_y = (yyvsp[(4) - (4)].i_value);
                   }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1078 "parser.y"
    { config.X_gamma = (yyvsp[(2) - (2)].i_value); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1079 "parser.y"
    { config.X_fullscreen = (yyvsp[(2) - (2)].i_value); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1080 "parser.y"
    { config.vgaemu_memsize = (yyvsp[(2) - (2)].i_value); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1081 "parser.y"
    { set_vesamodes((yyvsp[(2) - (3)].i_value),(yyvsp[(3) - (3)].i_value),0);}
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1082 "parser.y"
    { set_vesamodes((yyvsp[(2) - (4)].i_value),(yyvsp[(3) - (4)].i_value),(yyvsp[(4) - (4)].i_value));}
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1083 "parser.y"
    { set_vesamodes((yyvsp[(2) - (4)].i_value),(yyvsp[(4) - (4)].i_value),0);}
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1085 "parser.y"
    { set_vesamodes((yyvsp[(2) - (6)].i_value),(yyvsp[(4) - (6)].i_value),(yyvsp[(6) - (6)].i_value));}
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1086 "parser.y"
    { config.X_lfb = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1087 "parser.y"
    { config.X_pm_interface = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1088 "parser.y"
    { free(config.X_mgrab_key); config.X_mgrab_key = (yyvsp[(2) - (2)].s_value); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1089 "parser.y"
    { config.X_background_pause = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1096 "parser.y"
    { if (!priv_lvl) dexe_forbid_disk = 0; }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1097 "parser.y"
    {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
		}
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1101 "parser.y"
    {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
			else if (dexe_running) {
			  yyerror("this DEXE requires X, giving up");
			  exit(99);
			}
		}
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1116 "parser.y"
    { config.sb_base = (yyvsp[(2) - (2)].i_value); }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1117 "parser.y"
    { config.sb_dma = (yyvsp[(2) - (2)].i_value); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1118 "parser.y"
    { config.sb_hdma = (yyvsp[(2) - (2)].i_value); }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1119 "parser.y"
    { config.sb_irq = (yyvsp[(2) - (2)].i_value); }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1120 "parser.y"
    { free(config.sb_mixer); config.sb_mixer = (yyvsp[(2) - (2)].s_value); }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1121 "parser.y"
    { free(config.sb_dsp); config.sb_dsp = (yyvsp[(2) - (2)].s_value); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1122 "parser.y"
    { config.mpu401_base = (yyvsp[(2) - (2)].i_value); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1123 "parser.y"
    { free(config.sound_driver); config.sound_driver = (yyvsp[(2) - (2)].s_value); }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1128 "parser.y"
    { config.oss_min_frags = (yyvsp[(2) - (2)].i_value); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1129 "parser.y"
    { config.oss_max_frags = (yyvsp[(2) - (2)].i_value); }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1130 "parser.y"
    { config.oss_stalled_frags = (yyvsp[(2) - (2)].i_value); }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1131 "parser.y"
    { config.oss_do_post = (yyvsp[(2) - (2)].i_value); }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1132 "parser.y"
    { config.oss_min_extra_frags = (yyvsp[(2) - (2)].i_value); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1133 "parser.y"
    { config.oss_dac_freq = (yyvsp[(2) - (2)].i_value); }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1141 "parser.y"
    { set_joy_device((yyvsp[(2) - (2)].s_value)); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1142 "parser.y"
    { config.joy_dos_min = (yyvsp[(2) - (2)].i_value); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1143 "parser.y"
    { config.joy_dos_max = (yyvsp[(2) - (2)].i_value); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1144 "parser.y"
    { config.joy_granularity = (yyvsp[(2) - (2)].i_value); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1145 "parser.y"
    { config.joy_latency = (yyvsp[(2) - (2)].i_value); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1153 "parser.y"
    { config.cardtype = CARD_VGA; }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1154 "parser.y"
    { config.cardtype = CARD_MDA; }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1155 "parser.y"
    { config.cardtype = CARD_CGA; }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1156 "parser.y"
    { config.cardtype = CARD_EGA; }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1157 "parser.y"
    { config.cardtype = CARD_NONE; }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1159 "parser.y"
    {
		    config.chipset = (yyvsp[(2) - (2)].i_value);
                    c_printf("CHIPSET: %d\n", (yyvsp[(2) - (2)].i_value));
		    }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1163 "parser.y"
    { config.gfxmemsize = (yyvsp[(2) - (2)].i_value); }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1165 "parser.y"
    { config.vga = 1;
		    }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1168 "parser.y"
    { config.console_video = 1;
		    }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1170 "parser.y"
    { config.fullrestore = 1; }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1171 "parser.y"
    { config.fullrestore = 0; }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1172 "parser.y"
    { free(config.vbios_file); config.vbios_file = (yyvsp[(2) - (2)].s_value);
					  config.mapped_bios = 1;
					  config.vbios_copy = 0; }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1175 "parser.y"
    { free(config.vgaemubios_file); config.vgaemubios_file = (yyvsp[(2) - (2)].s_value); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1176 "parser.y"
    { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1180 "parser.y"
    { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1185 "parser.y"
    {
		   config.vbios_seg = (yyvsp[(2) - (2)].i_value);
		   c_printf("CONF: VGA-BIOS-Segment %x\n", (yyvsp[(2) - (2)].i_value));
		   if (((yyvsp[(2) - (2)].i_value) != 0xe000) && ((yyvsp[(2) - (2)].i_value) != 0xc000))
		      {
		      config.vbios_seg = detect_vbios_seg();
		      if (config.vbios_seg == -1) config.vbios_seg = 0xc000;
		      c_printf("CONF: VGA-BIOS-Segment set to 0x%x\n", config.vbios_seg);
		      }
		   }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1196 "parser.y"
    {
		   config.vbios_size = (yyvsp[(2) - (2)].i_value);
		   c_printf("CONF: VGA-BIOS-Size %x\n", (yyvsp[(2) - (2)].i_value));
		   if (((yyvsp[(2) - (2)].i_value) != 0x8000) && ((yyvsp[(2) - (2)].i_value) != 0x10000))
		      {
		      config.vbios_size = detect_vbios_size();
		      if (config.vbios_size == -1) config.vbios_size = 0x10000;
		      c_printf("CONF: VGA-BIOS-Size set to 0x%x\n", config.vbios_size);
		      }
		   }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1206 "parser.y"
    { config.vbios_post = 1; }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1207 "parser.y"
    { config.dualmon = 1; }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1208 "parser.y"
    { config.force_vt_switch = 1; }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1209 "parser.y"
    { config.pci_video = 1; }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1211 "parser.y"
    { yyerror("unrecognized video option '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1221 "parser.y"
    { config.term_esc_char = (yyvsp[(2) - (2)].i_value); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1222 "parser.y"
    { config.term_updatefreq = (yyvsp[(2) - (2)].i_value); }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1223 "parser.y"
    { config.term_color = ((yyvsp[(2) - (2)].i_value)!=0); }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1225 "parser.y"
    { yyerror("unrecognized terminal option '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1239 "parser.y"
    { set_debug_level('v', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1240 "parser.y"
    { set_debug_level('a', 0); }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1241 "parser.y"
    { set_debug_level('s', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1242 "parser.y"
    { set_debug_level('c', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1243 "parser.y"
    { set_debug_level('d', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1244 "parser.y"
    { set_debug_level('R', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1245 "parser.y"
    { set_debug_level('W', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1246 "parser.y"
    { set_debug_level('k', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1247 "parser.y"
    { set_debug_level('k', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1248 "parser.y"
    { set_debug_level('p', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1249 "parser.y"
    { set_debug_level('i', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1250 "parser.y"
    { set_debug_level('i', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1251 "parser.y"
    { set_debug_level('w', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1252 "parser.y"
    { set_debug_level('g', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1253 "parser.y"
    { set_debug_level('X', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1254 "parser.y"
    { set_debug_level('M', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1255 "parser.y"
    { set_debug_level('m', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1256 "parser.y"
    { set_debug_level('h', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1257 "parser.y"
    { set_debug_level('I', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1258 "parser.y"
    { set_debug_level('E', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1259 "parser.y"
    { set_debug_level('n', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1260 "parser.y"
    { set_debug_level('X', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1261 "parser.y"
    { set_debug_level('S', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1262 "parser.y"
    { set_debug_level('j', ((yyvsp[(2) - (2)].i_value)!=0)); }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1264 "parser.y"
    { yyerror("unrecognized debug flag '%s'", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1273 "parser.y"
    { free(mptr->dev); mptr->dev = (yyvsp[(2) - (2)].s_value); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1274 "parser.y"
    { mptr->intdrv = TRUE; }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1275 "parser.y"
    { mptr->emulate3buttons = TRUE; }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1276 "parser.y"
    { mptr->baudRate = (yyvsp[(2) - (2)].i_value); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1278 "parser.y"
    { if (mptr->type == MOUSE_MOUSESYSTEMS)
			 mptr->cleardtr = TRUE;
		      else
			 yyerror("option CLEARDTR is only valid for MicroSystems-mice");
		    }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1284 "parser.y"
    {
		  mptr->type = MOUSE_MICROSOFT;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1289 "parser.y"
    {
		  mptr->type = MOUSE_MS3BUTTON;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1294 "parser.y"
    {
		  mptr->type = MOUSE_MOUSESYSTEMS;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
/* is cstopb needed?  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL; */
		  }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1300 "parser.y"
    {
		  mptr->type = MOUSE_MMSERIES;
		  mptr->flags = CS8 | PARENB | PARODD | CREAD | CLOCAL | HUPCL;
		  }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1305 "parser.y"
    {
		  mptr->type = MOUSE_LOGITECH;
		  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL;
		  }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1310 "parser.y"
    {
		  mptr->type = MOUSE_PS2;
		  mptr->flags = 0;
		  }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1315 "parser.y"
    {
		  mptr->type = MOUSE_IMPS2;
		  mptr->flags = 0;
		  }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1320 "parser.y"
    {
		  mptr->type = MOUSE_MOUSEMAN;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1325 "parser.y"
    {
		  mptr->type = MOUSE_HITACHI;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
		  }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1330 "parser.y"
    {
		  mptr->type = MOUSE_BUSMOUSE;
		  mptr->flags = 0;
		  }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1335 "parser.y"
    { yyerror("unrecognized mouse flag '%s'", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1344 "parser.y"
    { keyb_layout((yyvsp[(2) - (2)].i_value)); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1345 "parser.y"
    {keyb_layout((yyvsp[(2) - (2)].i_value));}
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1346 "parser.y"
    { keyb_layout(KEYB_NO); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1347 "parser.y"
    { keyb_layout(-1); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1348 "parser.y"
    { config.console_keyb = (yyvsp[(2) - (2)].i_value); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1350 "parser.y"
    { yyerror("unrecognized keyboard flag '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value));}
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1359 "parser.y"
    { keyb_mod('C', (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1360 "parser.y"
    { keyb_mod('a', (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1361 "parser.y"
    { keyb_mod('c', (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1362 "parser.y"
    { keyb_mod(' ', (yyvsp[(1) - (2)].i_value), 0); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1363 "parser.y"
    { keyb_mod('S', (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1364 "parser.y"
    { keyb_mod('A', (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1365 "parser.y"
    { keyb_mod('N', (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1372 "parser.y"
    { keyb_mod(0, (yyvsp[(1) - (1)].i_value), 1); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1373 "parser.y"
    { keyb_mod(0, KEY_DEAD_GRAVE, 1); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1374 "parser.y"
    { keyb_mod(0, KEY_DEAD_ACUTE, 1); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1375 "parser.y"
    { keyb_mod(0, KEY_DEAD_CIRCUMFLEX, 1); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1376 "parser.y"
    { keyb_mod(0, KEY_DEAD_TILDE, 1); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1377 "parser.y"
    { keyb_mod(0, KEY_DEAD_BREVE, 1); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1378 "parser.y"
    { keyb_mod(0, KEY_DEAD_ABOVEDOT, 1); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1379 "parser.y"
    { keyb_mod(0, KEY_DEAD_DIAERESIS, 1); }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1380 "parser.y"
    { keyb_mod(0, KEY_DEAD_ABOVERING, 1); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1381 "parser.y"
    { keyb_mod(0, KEY_DEAD_DOUBLEACUTE, 1); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1382 "parser.y"
    { keyb_mod(0, KEY_DEAD_CEDILLA, 1); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1383 "parser.y"
    { keyb_mod(0, KEY_VOID, 1); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1384 "parser.y"
    { keyb_mod(0,KEY_DEAD_OGONEK, 1); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1385 "parser.y"
    { keyb_mod(0, KEY_DEAD_CARON, 1); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1386 "parser.y"
    { keyb_mod(0, (yyvsp[(1) - (1)].i_value), 0); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1387 "parser.y"
    { keyb_mod(0, (yyvsp[(2) - (3)].i_value), 0); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1388 "parser.y"
    {
			char *p = (yyvsp[(1) - (1)].s_value);
			while (*p) keyb_mod(0, *p++, 0);
			free((yyvsp[(1) - (1)].s_value));
		}
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1400 "parser.y"
    { free(config.tty_lockdir); config.tty_lockdir = (yyvsp[(2) - (2)].s_value); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1401 "parser.y"
    { free(config.tty_lockfile); config.tty_lockfile = (yyvsp[(2) - (2)].s_value); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1402 "parser.y"
    { config.tty_lockbinary = TRUE; }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1404 "parser.y"
    { yyerror("unrecognized ttylocks flag '%s'", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1413 "parser.y"
    { free(sptr->dev); sptr->dev = (yyvsp[(2) - (2)].s_value);
					  if (!strcmp("/dev/mouse",sptr->dev)) sptr->mouse=1; }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1415 "parser.y"
    {
					   if (isatty(0)) {
					     sptr->virtual = TRUE;
					     sptr->pseudo = TRUE;
					     no_local_video = 1;
					     sptr->dev = strdup(ttyname(0));
					   } else {
					     error("FD 0 is not a tty, can't "
					           "use a virtual com port\n");
					     exit(1);
					   }
					  }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1427 "parser.y"
    { sptr->real_comport = (yyvsp[(2) - (2)].i_value);
					  com_port_used[(yyvsp[(2) - (2)].i_value)] = 1; }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1429 "parser.y"
    { sptr->base_port = (yyvsp[(2) - (2)].i_value); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1430 "parser.y"
    { sptr->interrupt = (yyvsp[(2) - (2)].i_value); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1431 "parser.y"
    { sptr->interrupt = (yyvsp[(2) - (2)].i_value); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1432 "parser.y"
    { sptr->mouse = 1; }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1434 "parser.y"
    { yyerror("unrecognized serial flag '%s'", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1443 "parser.y"
    { c_printers = (yyvsp[(2) - (2)].i_value) - 1; }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1444 "parser.y"
    { pptr->prtcmd = (yyvsp[(2) - (2)].s_value); }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1445 "parser.y"
    { pptr->delay = (yyvsp[(2) - (2)].i_value); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1446 "parser.y"
    { pptr->dev = (yyvsp[(2) - (2)].s_value); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1447 "parser.y"
    { pptr->base_port = (yyvsp[(2) - (2)].i_value); }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1449 "parser.y"
    { yyerror("unrecognized printer flag %s", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1456 "parser.y"
    {
		  if (dptr->boot_name != NULL)
		    yyerror("Two names for a boot-image file or device given.");
		  dptr->boot_name = (yyvsp[(2) - (2)].s_value);
                  }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1467 "parser.y"
    { dptr->wantrdonly = 1; }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1468 "parser.y"
    { dptr->default_cmos = THREE_INCH_FLOPPY; }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1469 "parser.y"
    { dptr->default_cmos = THREE_INCH_288MFLOP; }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1470 "parser.y"
    { dptr->default_cmos = THREE_INCH_720KFLOP; }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1471 "parser.y"
    { dptr->default_cmos = ATAPI_FLOPPY; }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1472 "parser.y"
    { dptr->default_cmos = FIVE_INCH_FLOPPY; }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1473 "parser.y"
    { dptr->diskcyl4096 = 1; }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1474 "parser.y"
    { dptr->sectors = (yyvsp[(2) - (2)].i_value); }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1475 "parser.y"
    { dptr->tracks = (yyvsp[(2) - (2)].i_value); }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1476 "parser.y"
    { dptr->tracks = (yyvsp[(2) - (2)].i_value); }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1477 "parser.y"
    { dptr->heads = (yyvsp[(2) - (2)].i_value); }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1478 "parser.y"
    { dptr->header = (yyvsp[(2) - (2)].i_value); }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1480 "parser.y"
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[(2) - (3)].s_value);
		  }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1486 "parser.y"
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[(2) - (2)].s_value);
		  }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1492 "parser.y"
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk-image file given.");
		  dptr->type = IMAGE;
		  dptr->header = HEADER_SIZE;
		  dptr->dev_name = (yyvsp[(2) - (2)].s_value);
		  }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1500 "parser.y"
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk given.");
		  dptr->type = HDISK;
		  dptr->dev_name = (yyvsp[(2) - (3)].s_value);
		  }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1507 "parser.y"
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a floppy-device given.");
		  dptr->type = FLOPPY;
		  dptr->dev_name = (yyvsp[(2) - (2)].s_value);
		  }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1514 "parser.y"
    {
                  yywarn("{ partition \"%s\" %d } the"
			 " token '%d' is ignored and can be removed.",
			 (yyvsp[(2) - (4)].s_value),(yyvsp[(3) - (4)].i_value),(yyvsp[(3) - (4)].i_value));
		  do_part((yyvsp[(2) - (4)].s_value));
		  }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 1521 "parser.y"
    { do_part((yyvsp[(2) - (3)].s_value)); }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 1523 "parser.y"
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[(2) - (2)].s_value);
		  }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1530 "parser.y"
    { yyerror("unrecognized disk flag '%s'\n", (yyvsp[(1) - (1)].s_value)); free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1540 "parser.y"
    {
		   c_printf("CONF: I/O port 0x%04x\n", (unsigned short)(yyvsp[(1) - (1)].i_value));
	           allow_io((yyvsp[(1) - (1)].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (abs(portspeed)) portspeed += ((portspeed>0) ? 1 : -1);
	           }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 1547 "parser.y"
    {
	           allow_io((yyvsp[(2) - (3)].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (abs(portspeed)) portspeed += ((portspeed>0) ? 1 : -1);
	           }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1553 "parser.y"
    {
		   if (abs(portspeed) > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[(2) - (3)].i_value), (unsigned short)(yyvsp[(3) - (3)].i_value));
		   allow_io((yyvsp[(2) - (3)].i_value), (yyvsp[(3) - (3)].i_value) - (yyvsp[(2) - (3)].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 1563 "parser.y"
    {
		   if (abs(portspeed) > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[(2) - (4)].i_value), (unsigned short)(yyvsp[(4) - (4)].i_value));
		   allow_io((yyvsp[(2) - (4)].i_value), (yyvsp[(4) - (4)].i_value) - (yyvsp[(2) - (4)].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1572 "parser.y"
    { ports_permission = IO_READ; }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1573 "parser.y"
    { ports_permission = IO_WRITE; }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1574 "parser.y"
    { ports_permission = IO_RDWR; }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1575 "parser.y"
    { ports_ormask = (yyvsp[(2) - (2)].i_value); }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 1576 "parser.y"
    { ports_andmask = (yyvsp[(2) - (2)].i_value); }
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 1577 "parser.y"
    { portspeed = 1; }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 1578 "parser.y"
    { portspeed = -1; }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1579 "parser.y"
    { strcpy(dev_name,(yyvsp[(2) - (2)].s_value)); free((yyvsp[(2) - (2)].s_value)); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1581 "parser.y"
    { yyerror("unrecognized port command '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1590 "parser.y"
    { register_port_traceing((yyvsp[(1) - (1)].i_value), (yyvsp[(1) - (1)].i_value)); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1592 "parser.y"
    { register_port_traceing((yyvsp[(2) - (3)].i_value), (yyvsp[(2) - (3)].i_value)); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 1594 "parser.y"
    { register_port_traceing((yyvsp[(2) - (3)].i_value), (yyvsp[(3) - (3)].i_value)); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1596 "parser.y"
    { register_port_traceing((yyvsp[(2) - (4)].i_value), (yyvsp[(4) - (4)].i_value)); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1597 "parser.y"
    { clear_port_traceing(); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 1599 "parser.y"
    { yyerror("unrecognized port trace command '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 1609 "parser.y"
    { set_irq_value(1, (yyvsp[(1) - (1)].i_value)); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1610 "parser.y"
    { set_irq_value(1, (yyvsp[(2) - (3)].i_value)); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1611 "parser.y"
    { set_irq_value(0x10001, (yyvsp[(2) - (2)].i_value)); }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 1612 "parser.y"
    { set_irq_range(1, (yyvsp[(2) - (3)].i_value), (yyvsp[(3) - (3)].i_value)); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1613 "parser.y"
    { set_irq_range(1, (yyvsp[(2) - (4)].i_value), (yyvsp[(4) - (4)].i_value)); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1614 "parser.y"
    { set_irq_range(0x10001, (yyvsp[(3) - (4)].i_value), (yyvsp[(4) - (4)].i_value)); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1615 "parser.y"
    { set_irq_range(0x10001, (yyvsp[(3) - (5)].i_value), (yyvsp[(5) - (5)].i_value)); }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 1617 "parser.y"
    { yyerror("unrecognized irqpassing command '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1628 "parser.y"
    {
		     config.ems_size = (yyvsp[(1) - (1)].i_value);
		     if ((yyvsp[(1) - (1)].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[(1) - (1)].i_value));
	           }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 1633 "parser.y"
    {
		     config.ems_size = (yyvsp[(2) - (3)].i_value);
		     if ((yyvsp[(2) - (3)].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[(2) - (3)].i_value));
	           }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1638 "parser.y"
    {
		     config.ems_size = (yyvsp[(2) - (2)].i_value);
		     if ((yyvsp[(2) - (2)].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[(2) - (2)].i_value));
		   }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1643 "parser.y"
    {
/* is there a technical reason why the EMS frame can't be at 0xC0000 or
   0xA0000 if there's space? */
#if 0
		     if ( (((yyvsp[(2) - (2)].i_value) & 0xfc00)>=0xc800) && (((yyvsp[(2) - (2)].i_value) & 0xfc00)<=0xe000) ) {
		       config.ems_frame = (yyvsp[(2) - (2)].i_value) & 0xfc00;
		       c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		     }
		     else yyerror("wrong EMS-frame: 0x%04x", (yyvsp[(2) - (2)].i_value));
#endif
	             config.ems_frame = (yyvsp[(2) - (2)].i_value) & 0xfc00;
		     c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		   }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1657 "parser.y"
    { yyerror("unrecognized ems command '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1668 "parser.y"
    {
                     if (!register_hardware_ram('h', (yyvsp[(1) - (1)].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[(1) - (1)].i_value));
                     }
	           }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 1674 "parser.y"
    {
                     if (!register_hardware_ram('h', (yyvsp[(2) - (3)].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[(2) - (3)].i_value));
                     }
	           }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1680 "parser.y"
    {
                     if (register_hardware_ram('h', (yyvsp[(2) - (3)].i_value), (yyvsp[(3) - (3)].i_value) - (yyvsp[(2) - (3)].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[(2) - (3)].i_value), (yyvsp[(3) - (3)].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[(2) - (3)].i_value));
		   }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 1687 "parser.y"
    {
                     if (register_hardware_ram('h', (yyvsp[(2) - (4)].i_value), (yyvsp[(4) - (4)].i_value) - (yyvsp[(2) - (4)].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[(2) - (4)].i_value), (yyvsp[(4) - (4)].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[(2) - (4)].i_value));
		   }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 1694 "parser.y"
    { yyerror("unrecognized hardware ram command '%s'", (yyvsp[(1) - (1)].s_value));
		      free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 1708 "parser.y"
    {
			if ((yyvsp[(1) - (1)].i_value) == -2) {
				yyerror("got 'on', expected 'off' or an integer");
			}
		}
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 1715 "parser.y"
    {
			if ( (yyvsp[(1) - (1)].i_value) && (((yyvsp[(1) - (1)].i_value) < 2) || ((yyvsp[(1) - (1)].i_value) > 15)) ) {
				yyerror("got '%d', expected 'off' or an integer 2..15", (yyvsp[(1) - (1)].i_value));
			} 
		}
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 1724 "parser.y"
    { (yyval.i_value) = SPKR_OFF; }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 1725 "parser.y"
    { (yyval.i_value) = SPKR_NATIVE; }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 1726 "parser.y"
    { (yyval.i_value) = SPKR_EMULATED; }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 1727 "parser.y"
    { yyerror("got '%s', expected 'emulated' or 'native'", (yyvsp[(1) - (1)].s_value));
				  free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 1729 "parser.y"
    { yyerror("expected 'emulated' or 'native'"); }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 1734 "parser.y"
    { (yyval.i_value) = 0; }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 1735 "parser.y"
    { (yyval.i_value) = 3; }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 1736 "parser.y"
    { (yyval.i_value) = 4; }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 1737 "parser.y"
    { (yyval.i_value) = 5; }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 1738 "parser.y"
    { (yyval.i_value) = 6; }
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 1739 "parser.y"
    { yyerror("got '%s', expected 'off', 'vm86' or 'full'", (yyvsp[(1) - (1)].s_value));
				  free((yyvsp[(1) - (1)].s_value)); }
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 1741 "parser.y"
    { yyerror("expected 'off', 'vm86' or 'full'"); }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 1748 "parser.y"
    { set_internal_charset ((yyvsp[(2) - (2)].s_value)); free((yyvsp[(2) - (2)].s_value)); }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 1749 "parser.y"
    { set_external_charset ((yyvsp[(2) - (2)].s_value)); free((yyvsp[(2) - (2)].s_value)); }
    break;



/* Line 1806 of yacc.c  */
#line 6853 "parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1752 "parser.y"


	/* features */

static void handle_features(int which, int value)
{
  if ((which < 0)
	|| (which >= (sizeof(config.features) / sizeof(config.features[0])))) {
    c_printf("CONF: wrong feature number %d\n", which);
    return;
  }
  config.features[which] = value;
  c_printf("CONF: feature %d set to %d\n", which, value);
}

	/* joystick */

static void set_joy_device(char *devstring)
{
  char *spacepos;

  free(config.joy_device[0]);
  config.joy_device[0] = devstring;
  config.joy_device[1] = NULL;
  spacepos = strchr(devstring, ' ');
  if (spacepos != NULL) {
    *spacepos = '\0';
    config.joy_device[1] = spacepos + 1;
  }
}

	/* mouse */

static void start_mouse(void)
{
  mptr = &config.mouse;
  mptr->fd = -1;
}

static void stop_mouse(void)
{
  c_printf("MOUSE: %s, type %x using internaldriver: %s, emulate3buttons: %s baudrate: %d\n", 
        mptr->dev && mptr->dev[0] ? mptr->dev : "no device specified",
        mptr->type, mptr->intdrv ? "yes" : "no", 
        mptr->emulate3buttons ? "yes" : "no", mptr->baudRate);
}

	/* debug */

static void start_ports(void)
{
  if (priv_lvl)
    yyerror("Can not change port privileges in user config file");
  ports_permission = IO_RDWR;
  ports_ormask = 0;
  ports_andmask = 0xFFFF;
}

	/* debug */

static void start_debug(void)
{
  set_debug_level('a', 0);	      /* Default is no debugging output at all */
}

	/* video */

static void start_video(void)
{
  free(config.vbios_file);
  config.vbios_file = NULL;
  config.vbios_copy = 0;
  config.vbios_seg  = 0xc000;
  config.vbios_size = 0x10000;
  config.console_video = 0;
  config.cardtype = CARD_NONE;
  config.chipset = PLAINVGA;
  config.mapped_bios = 0;
  config.vga = 0;
  config.gfxmemsize = 256;
  config.fullrestore = 0;
  config.dualmon = 0;
  config.force_vt_switch = 0;
}

static void stop_video(void)
{
  if (priv_lvl)
    config.console_video = 0;

  if ((config.cardtype != CARD_VGA) || !config.console_video) {
    config.vga = 0;
  }
}

	/* vesa modes */
static void set_vesamodes(int width, int height, int color_bits)
{
  vesamode_type *vmt = malloc(sizeof *vmt);
  if(vmt != NULL) {
    vmt->width = width;
    vmt->height = height;
    vmt->color_bits = color_bits;
    vmt->next = config.vesamode_list;
    config.vesamode_list = vmt;
  }
}

	/* vbios detection */
static int auto_vbios_seg = -1;
static int auto_vbios_size = -1;

static void detect_vbios(void)
{
  unsigned char c[0x21];
  int foffset;

  if (auto_vbios_seg != -1) return;
  if (!can_do_root_stuff || config.vbios_file) return;
  for (foffset = 0xc0000; foffset < 0xf0000; foffset += 0x800) {
    load_file("/dev/mem", foffset, c, sizeof(c));
    if (c[0]==0x55 && c[1]==0xaa
        && c[0x1e]=='I' && c[0x1f]=='B' && c[0x20]=='M') {
      auto_vbios_seg = foffset >> 4;
      auto_vbios_size = c[2]*0x200;
      break;
    }
  }
}

static int detect_vbios_seg(void)
{
  detect_vbios();
  return auto_vbios_seg;
}

static int detect_vbios_size(void)
{
  detect_vbios();
  return auto_vbios_size;
}

static void stop_ttylocks(void)
{
  c_printf("SER: directory %s namestub %s binary %s\n", config.tty_lockdir,
	   config.tty_lockfile,(config.tty_lockbinary?"Yes":"No"));
}

	/* serial */

static void start_serial(void)
{
  if (c_ser >= MAX_SER)
    sptr = &nullser;
  else {
    /* The defaults for interrupt, base_port, real_comport and dev are 
    ** automatically filled in inside the do_ser_init routine of serial.c
    */
    sptr = &com[c_ser];
    sptr->dev = NULL;
    sptr->interrupt = 0; 
    sptr->base_port = 0;
    sptr->real_comport = 0;
    sptr->fd = -1;
    sptr->mouse = 0;
    sptr->virtual = FALSE;
    sptr->pseudo = FALSE;
  }
}


static void stop_serial(void)
{
  if (sptr->dev[0] == '\0')
    return;
  if (c_ser >= MAX_SER) {
    c_printf("SER: too many ports, ignoring %s\n", sptr->dev);
    return;
  }
  c_ser++;
  config.num_ser = c_ser;
  c_printf("SER: %s port %x int %x\n", sptr->dev, sptr->base_port,
	   sptr->interrupt);
}

	/* keyboard */

static int keyboard_statement_already = 0;

static void start_keyboard(void)
{
  keyb_layout(KEYB_USER); /* NOTE: the default has changed, --Hans, 971204 */
  config.console_keyb = 0;
  keyboard_statement_already = 1;
}

static void stop_terminal(void)
{
  if (config.term_updatefreq > 100) {
    yywarn("terminal updatefreq too large (too slow)!");
    config.term_updatefreq = 100;
  } 
}

	/* printer */

static void start_printer(void)
{
  pptr->prtcmd = NULL;
  pptr->dev = NULL;
  pptr->file = NULL;
  pptr->remaining = -1;
  pptr->delay = 10;
}

static void stop_printer(void)
{
  printer_config(c_printers, pptr);
  c_printf("CONF(LPT%d) f: %s   c: %s  t: %d  port: %x\n",
           c_printers, pptr->dev, pptr->prtcmd,
           pptr->delay, pptr->base_port);
  c_printers++;
  if (c_printers > config.num_lpt)
    config.num_lpt = c_printers;
}

	/* disk */

static void start_bootdisk(void)
{
  if (config.bootdisk)           /* Already a bootdisk configured ? */
    yyerror("There is already a bootdisk configured");
      
  dptr = &bootdisk;              /* set pointer do bootdisk-struct */
      
  dptr->diskcyl4096 = 0;
  dptr->sectors = 0;             /* setup default-values           */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->boot_name = NULL;
  dptr->wantrdonly = 0;
  dptr->header = 0;
}

static void start_floppy(void)
{
  if (c_fdisks >= MAX_FDISKS)
    {
    yyerror("There are too many floppy disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &disktab[c_fdisks];

  dptr->sectors = 0;             /* setup default values */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->boot_name = NULL;
  dptr->wantrdonly = 0;
  dptr->header = 0;
}

static void start_disk(void)
{
  if (c_hdisks >= MAX_HDISKS) 
    {
    yyerror("There are too many hard disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &hdisktab[c_hdisks];
      
  dptr->type    =  NODISK;
  dptr->sectors = -1;
  dptr->heads   = -1;
  dptr->tracks  = -1;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->boot_name = NULL;
  dptr->wantrdonly = 0;
  dptr->header = 0;
  dptr->dexeflags = 0;
}

static void start_vnet(char *mode) {
  if (strcmp(mode, "tap") == 0) {
    config.vnet = VNET_TYPE_TAP;
    return;
  }
  IFCLASS(CL_NET);
  if (strlen(mode) == 0 || strcmp(mode, "direct") == 0)
    config.vnet = VNET_TYPE_ETH;
  else if (strcmp(mode, "dosnet") == 0)
    config.vnet = VNET_TYPE_DSN;
  else {
    error("Unknown vnet mode \"%s\"\n", mode);
    config.exitearly = 1;
  } 
}

static void do_part(char *dev)
{
  if (dptr->dev_name != NULL)
    yyerror("Two names for a partition given.");
  dptr->type = PARTITION;
  dptr->dev_name = dev;
#ifdef __linux__
  dptr->part_info.number = atoi(dptr->dev_name+8);
#endif
  if (dptr->part_info.number == 0) 
    yyerror("%s must be a PARTITION, can't find number suffix!\n",
   	    dptr->dev_name);
}

static void stop_disk(int token)
{
#ifdef __linux__
  FILE   *f;
  struct mntent *mtab;
#endif
  int    mounted_rw;

  if (dexe_running && dexe_forbid_disk)
    return;
  if (dptr == &nulldisk)              /* is there any disk? */
    return;                           /* no, nothing to do */

  if (!dptr->dev_name)                /* Is there a file/device-name? */
    yyerror("disk: no device/file-name given!");
  else                                /* check the file/device for existance */
    {
      struct stat file_status;        /* date for checking that file */

      c_printf("device: %s ", dptr->dev_name);
      if (stat(dptr->dev_name,&file_status) != 0) { /* Does this file exist? */
	 if (config.install ||
	     strcmp(dptr->dev_name, DOSEMUHDIMAGE_DEFAULT"/drives/*") == 0) {
	    /* default setting: display a menu */
	    dptr->type = DIR_TYPE;
	    if (!config.install)
	       config.install = "";
	 } else
	    yyerror("Disk-device/file %s doesn't exist.",dptr->dev_name);
      }
    }

  if (dptr->type == NODISK)    /* Is it one of bootdisk, floppy, harddisk ? */
    yyerror("disk: no device/file-name given!"); /* No, error */
  else
    c_printf("type %d ", dptr->type);

  if (dptr->type == PARTITION) {
    c_printf("partition# %d ", dptr->part_info.number);
#ifdef __linux__
    mtab = NULL;
    if ((f = setmntent(MOUNTED, "r")) != NULL) {
      while ((mtab = getmntent(f)))
        if (!strcmp(dptr->dev_name, mtab->mnt_fsname)) break;
      endmntent(f);
    }
    if (mtab) {
      mounted_rw = ( hasmntopt(mtab, MNTOPT_RW) != NULL );
      if (mounted_rw && !dptr->wantrdonly) 
        yyerror("\n\nYou specified '%s' for read-write Direct Partition Access,"
                "\nit is currently mounted read-write on '%s' !!!\n",
                dptr->dev_name, mtab->mnt_dir);
      else if (mounted_rw) 
        yywarn("You specified '%s' for read-only Direct Partition Access,"
               "\n         it is currently mounted read-write on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
      else if (!dptr->wantrdonly) 
        yywarn("You specified '%s' for read-write Direct Partition Access,"
               "\n         it is currently mounted read-only on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
    }
#endif
  }

  if (dptr->header)
    c_printf("header_size: %ld ", (long) dptr->header);

  c_printf("h: %d  s: %d   t: %d", dptr->heads, dptr->sectors,
	   dptr->tracks);

  if (token == BOOTDISK) {
    config.bootdisk = 1;
    use_bootdisk = 1;
    c_printf(" bootdisk\n");
  }
  else if (token == L_FLOPPY) {
    c_printf(" floppy %c:\n", 'A'+c_fdisks);
    c_fdisks++;
    config.fdisks = c_fdisks;
  }
  else {
    c_printf(" drive %c:\n", 'C'+c_hdisks);
    c_hdisks++;
    config.hdisks = c_hdisks;
  }
}

	/* keyboard */

void keyb_layout(int layout)
{
  struct keytable_entry *kt = keytable_list;
  if (layout == -1) {
    /* auto: do it later */
    config.keytable = NULL;
    return;
  }
  while (kt->name) {
    if (kt->keyboard == layout) {
      if (kt->flags & KT_ALTERNATE) {
        c_printf("CONF: Alternate keyboard-layout %s\n", kt->name);
        config.altkeytable = kt;
      } else {
      c_printf("CONF: Keyboard-layout %s\n", kt->name);
      config.keytable = kt;
      }
      return;
    }
    kt++;
  }
  c_printf("CONF: ERROR -- Keyboard has incorrect number!!!\n");
}

static void keytable_start(int layout)
{
  static struct keytable_entry *saved_kt = 0;
  if (layout == -1) {
    if (keyboard_statement_already) {
      if (config.keytable != saved_kt) {
        yywarn("keytable changed to %s table, but previously was defined %s\n",
                config.keytable->name, saved_kt->name);
      }
    }
  }
  else {
    saved_kt = config.keytable;
    keyb_layout(layout);
  }
}

static void keytable_stop(void)
{
  keytable_start(-1);
}

static void dump_keytables_to_file(char *name)
{
  FILE * f;
  struct keytable_entry *kt = keytable_list;

  f = fopen(name, "w");
  if (!f) {
    error("cannot create keytable file %s\n", name);
    exit(1);
  }
  
  while (kt->name) {
    dump_keytable(f, kt);
    kt++;
  }
  fclose(f);
  exit(0);
}

static void set_irq_value(int bits, int i1)
{
  if ((i1>2) && (i1<=15)) {
    config.sillyint |= (bits << i1);
    c_printf("CONF: IRQ %d for irqpassing", i1);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
  else yyerror("wrong IRQ for irqpassing command: %d", i1);
}

static void set_irq_range(int bits, int i1, int i2) {
  int i;
  if ( (i1<3) || (i1>15) || (i2<3) || (i2>15) || (i1 > i2 ) ) {
    yyerror("wrong IRQ range for irqpassing command: %d .. %d", i1, i2);
  }
  else {
    for (i=i1; i<=i2; i++) config.sillyint |= (bits << i);
    c_printf("CONF: range of IRQs for irqpassing %d .. %d", i1, i2);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
}


	/* errors & warnings */

void yywarn(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  fprintf(stderr, "Warning: ");
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  warnings++;
}

void yyerror(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  if (include_stack_ptr != 0 && !last_include) {
	  int i;
	  fprintf(stderr, "In file included from %s:%d\n",
		  include_fnames[0], include_lines[0]);
	  for(i = 1; i < include_stack_ptr; i++) {
		  fprintf(stderr, "                 from %s:%d\n",
			  include_fnames[i], include_lines[i]);
	  }
	  last_include = 1;
  }
  fprintf(stderr, "Error in %s: (line %.3d) ", 
	  include_fnames[include_stack_ptr], line_count);
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  errors++;
}


/*
 * open_file - opens the configuration-file named *filename and returns
 *             a file-pointer. The error/warning-counters are reset to zero.
 */

static FILE *open_file(char *filename)
{
  errors   = 0;                  /* Reset error counter */
  warnings = 0;                  /* Reset counter for warnings */

  if (!filename) return 0;
  return fopen(filename, "r"); /* Open config-file */
}

/*
 * close_file - Close the configuration file and issue a message about
 *              errors/warnings that occured. If there were errors, the
 *              flag early-exit is that, so dosemu won't really.
 */

static void close_file(FILE * file)
{
  if (file) fclose(file);                  /* Close the config-file */

  if(errors)
    fprintf(stderr, "%d error(s) detected while parsing the configuration-file\n",
	    errors);
  if(warnings)
    fprintf(stderr, "%d warning(s) detected while parsing the configuration-file\n",
	    warnings);

  if (errors != 0)               /* Exit dosemu on errors */
    {
      config.exitearly = TRUE;
    }
}

/* write_to_syslog */
static void write_to_syslog(char *message)
{
  openlog("dosemu", LOG_PID, LOG_USER | LOG_NOTICE);
  syslog(LOG_PID | LOG_USER | LOG_NOTICE, "%s", message);
  closelog();
}

static void move_dosemu_lib_dir(char *path)
{
  if (dosemu_lib_dir_path != path) {
    if (dosemu_lib_dir_path != dosemulib_default)
      free(dosemu_lib_dir_path);
    dosemu_lib_dir_path = strdup(path);
  }
  setenv("DOSEMU_LIB_DIR", dosemu_lib_dir_path, 1);
  if (keymap_load_base_path != keymaploadbase_default)
    free(keymap_load_base_path);
  keymap_load_base_path = assemble_path(path, "", 0);
}

static FILE *open_dosemu_users(void)
{
  FILE *fp;
  fp = open_file(DOSEMU_USERS_FILE);
  if (fp) return fp;
  return 0;
}

static void setup_home_directories(void)
{
  setenv("DOSEMU_HDIMAGE_DIR", dosemu_hdimage_dir_path, 1);
  LOCALDIR = get_dosemu_local_home();
  RUNDIR = mkdir_under(LOCALDIR, "run", 0);
  DOSEMU_MIDI_PATH = assemble_path(RUNDIR, DOSEMU_MIDI, 0);
  DOSEMU_MIDI_IN_PATH = assemble_path(RUNDIR, DOSEMU_MIDI_IN, 0);
}

static void lax_user_checking(void)
{
  char *p;
  define_config_variable("c_all");
  p = getenv("USER");
  if (!p) p = "guest";
  setenv("DOSEMU_USER", p, 1);
  setenv("DOSEMU_REAL_USER", p, 1);
  setup_home_directories();
}

/* Parse TimeMode, Paul Crawford and Andrew Brooks 2004-08-01 */
/* Accepts "bios", "pit", "linux", default is "bios". Use with TIMEMODE token */
int parse_timemode(const char *timemodestr)
{
   if (timemodestr == NULL || timemodestr[0] == '\0')
     return(TM_BIOS); /* default */
   if (strcmp(timemodestr, "linux")==0)
     return(TM_LINUX);
   if (strcmp(timemodestr, "pit")==0)
     return(TM_PIT);
   if (strcmp(timemodestr, "bios")==0)
     return(TM_BIOS);
   yyerror("Unrecognised time mode (not bios, pit or linux)");
   return(TM_BIOS);
}

/* Parse Users for DOSEMU, by Alan Hourihane, alanh@fairlite.demon.co.uk */
/* Jan-17-1996: Erik Mouw (J.A.K.Mouw@et.tudelft.nl)
 *  - added logging facilities
 * In 1998:     Hans
 *  - havy changes and re-arangments
 */
void
parse_dosemu_users(void)
{
#define ALL_USERS "all"
#define PBUFLEN 256

  FILE *volatile fp;
  struct passwd *pwd;
  char buf[PBUFLEN];
  int userok = 0;
  char *ustr;
  int log_syslog=0;
  int uid;
  int have_vars=0;

  /* We come here _very_ early (at top of main()) to avoid security conflicts.
   * priv_init() has already been called, but nothing more.
   *
   * We will exit, if /etc/dosemu.users says that the user has no right
   * to run a suid root dosemu (and we are on), but will continue, if the user
   * is running a non-suid copy _and_ is mentioned in dosemu users.
   * The dosemu.users entry for such a user is:
   *
   *      joeodd  ... nosuidroot
   *
   * The functions we call rely on the following setting:
   */
  after_secure_check = 0;
  priv_lvl = 0;

  /* We first have to find out where the dosemu.users file is placed
   * by the system administrator.
   * We first look for /etc/dosemu.users, then for /etc/dosemu/dosemu.users
   * Once we know that, most other pathes are runtime configurable:
   *
   *  - dosemu.users tells were to find the dosemu-lib-dir
   *    (DOSEMULIB_DEFAULT per default)
   *  - global.conf includes $DOSEMU_CONF_DIR/dosemu.conf
   *    (which could be changed by the owner of global.conf).
   */

  if (DOSEMU_USERS_FILE == NULL) {
    setenv("DOSEMU_CONF_DIR", "", 1);
  } else if (!exists_file(DOSEMU_USERS_FILE)) {
    DOSEMU_USERS_FILE = ALTERNATE_ETC "/" DOSEMU_USERS;
    DOSEMU_LOGLEVEL_FILE = ALTERNATE_ETC "/" DOSEMU_LOGLEVEL;
    setenv("DOSEMU_CONF_DIR", ALTERNATE_ETC, 1);
  }
  else setenv("DOSEMU_CONF_DIR", "/etc", 1);
	
  /* we check for some vital global settings
   * which we need before proceeding
   */
  setenv("DOSEMU_LIB_DIR", dosemulib_default, 1);
  move_dosemu_lib_dir(dosemu_lib_dir_path);

  fp = open_dosemu_users();
  if (fp) while (fgets(buf, PBUFLEN, fp) != NULL) {
    int l = strlen(buf);
    if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
    ustr = strtok(buf, " \t\n=,;:");
    if (ustr && (ustr[0] != '#')) {
      if (!strcmp(ustr, "default_lib_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_lib_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          move_dosemu_lib_dir(ustr);
        }
      }
      if (!strcmp(ustr, "default_hdimage_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_hdimage_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          if (dosemu_hdimage_dir_path != dosemuhdimage_default)
            free(dosemu_hdimage_dir_path);
          dosemu_hdimage_dir_path = strdup(ustr);
	  dexe_load_path = dosemu_hdimage_dir_path;
        }
      }
      else if (!strcmp(ustr, "log_level")) {
        int ll = 0;
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          ll = atoi(ustr);
          if (ll < 0) ll = 0;
          if (ll > 2) ll = 2;
        }
        log_syslog = ll;
      }
      else if (!strcmp(ustr, "config_script")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr && strcmp(ustr, DEFAULT_CONFIG_SCRIPT)) {
          config_script_path = strdup(ustr);
          if (!exists_file(config_script_path)) {
            char *tx = "config_script %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
	  config_script_name = strdup(ustr);
	}
      }
    }
  }
  if (fp) fclose(fp);

  if (!can_do_root_stuff || under_root_login) {
     /* simply ignore -- we're not suid-root */
     lax_user_checking();
     after_secure_check = 1;
     return;
  }

  /* We want to test if the _user_ is allowed to do certain privileged    */
  /* things, o check if the username connected to the get_orig_uid() is   */
  /* in the DOSEMU_USERS_FILE file (usually /etc/dosemu.users).           */
   
  uid = get_orig_uid();

  errno = 0; /* man says this is necessary?! */
  pwd = getpwuid(uid);

  /* Sanity Check, Shouldn't be anyone logged in without a userid */
  if (!pwd) 
     {
       error("Illegal User: uid=%i, error=%s\n", uid, strerror(errno));
       sprintf(buf, "Illegal DOSEMU user: uid=%i", uid);
       write_to_syslog(buf);
       exit(1);
     }

  /* preset DOSEMU_*USER env, such that a user can't fake it */
  setenv("DOSEMU_USER", "unknown", 1);
  setenv("DOSEMU_REAL_USER", pwd->pw_name, 1);

  {
       int can_have_privsetup = 0;
       fp = open_dosemu_users();
       if (fp) {
	   for(userok=0; fgets(buf, PBUFLEN, fp) != NULL && !userok; ) {
	     int l = strlen(buf);
	     if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
	     ustr = strtok(buf, " \t\n,;:");
	     if (ustr && (ustr[0] != '#')) {
	       if (strcmp(ustr, pwd->pw_name)== 0) 
		 userok = 1;
	       else if (strcmp(ustr, ALL_USERS)== 0)
		 userok = 1;
	       if (userok) {
		 setenv("DOSEMU_USER", ustr, 1);
		 while ((ustr=strtok(0, " \t,;:")) !=0) {
		   if (ustr[0] == '#') break;
		   define_config_variable(ustr);
		   have_vars = 1;
                   if (!strcmp(ustr,"private_setup")) {
                     can_have_privsetup = 1;
                   }
		 }
	         if (!have_vars && !using_sudo)
		   define_config_variable("restricted");
	       }
	     }
	   }
           fclose(fp);
       }
       

       if (can_have_privsetup
              && (   get_config_variable("unrestricted")
                  || under_root_login || !can_do_root_stuff)) {
         /* this user is allowed to have a privat ~/.dosemu/lib
          * (which replaces DOSEMULIB_DEFAULT if existing).
          * Hence this user can have its own global.conf e.t.c.
          * However, this is only possible with non-suid-root
          * binary or when running under root loggin or when 'unrestricted'
          * also is set.       -- Hans
          */
         char *lpath = get_path_in_HOME(LOCALDIR_BASE_NAME "/lib");
         if (exists_dir(lpath)) move_dosemu_lib_dir(lpath);
         free(lpath);
       }
  }

  define_config_variable("c_all");
  if(userok==0 && !using_sudo) {
    define_config_variable("restricted");
  }
  if (get_config_variable("nosuidroot") || (get_config_variable("restricted") && !on_console())) {
    fprintf(stderr, "Dropping root privileges: guest or a restricted user not on console.\n");
    priv_drop();
    lax_user_checking();
    after_secure_check = 1;
    return;
  }

  /* now we setup up our local DOSEMU home directory, where we
   * have (among other things) all temporary stuff in
   * (since 0.97.10.2)
   */
  setup_home_directories();
  after_secure_check = 1;
}


char *commandline_statements=0;

static int has_dexe_magic(char *name)
{
  int fd, magic, ret;
  fd = open(name, O_RDONLY);
  if (fd <0) return 0;
  ret = (read(fd, &magic, 4) == 4) && (magic == DEXE_MAGIC);
  close(fd);
  return ret;
}

static int stat_dexe(char *name)
{
  struct stat s;
  if (stat(name, &s)) return 0;
  if ( ! S_ISREG(s.st_mode)) return 0;
  if ((s.st_mode & S_IXUSR) && (s.st_uid == get_orig_uid()))
    return has_dexe_magic(name);
  if ((s.st_mode & S_IXGRP) && (is_in_groups(s.st_gid)))
    return  has_dexe_magic(name); 
  if (s.st_mode & S_IXOTH) return has_dexe_magic(name);
  return 0;
}

static char *resolve_exec_path(char *dexename, char *ext)
{
  enum { maxn=0x255 };
  static char n[maxn+1];
  static char name[maxn+1];
  char *p, *path=getenv("PATH");

  strncpy(name,dexename,maxn);
  name[maxn] = 0;
  n[maxn] = 0;
  p = rindex(name, '.');
  if ( ext && ((p && strcmp(p, ext)) || !p) )
    strncat(name,ext,maxn);


  /* first try the pure file name */
  if (!path || (name[0] == '/') || (!strncmp(name, "./", 2))) {
    if (stat_dexe(name)) return name;
    return 0;
  }

  /* next try the standard path for DEXE files */
  snprintf(n, maxn, "%s/%s", dexe_load_path, name);
  if (stat_dexe(n)) return n;

  /* now search in the users normal PATH */
  path = strdup(path);
  p= strtok(path,":");
  while (p) {
    snprintf(n, maxn, "%s/%s", p, name);
    if (stat_dexe(n)) {
      free(path);
      return n;
    }
    p=strtok(0,":");
  }
  free(path);
  return 0;
}

void prepare_dexe_load(char *name)
{
  char *n, *cbuf;
  int fd, csize;
  struct image_header ihdr;

  n = resolve_exec_path(name, ".dexe");
  if (!n) {
    n = resolve_exec_path(name, 0);
    if (!n) {
      error("DEXE file not found or not executable\n");
      exit(1);
    }
  }

  /* now we extract the configuration file and the access flags */
  fd = open(n, O_RDONLY);
  if (read(fd, &ihdr, sizeof(struct image_header)) != sizeof(struct image_header)) {
    error("broken DEXE format, can't read image header\n");
    close(fd);
    exit(1);
  }

  lseek(fd, HEADER_SIZE + 0x200, SEEK_SET); /* just behind the MBR */
  if ((read(fd, &csize, 4) != 4) || (csize > 0x2000)) {
    error("broken DEXE format, configuration not found\n");
    close(fd);
    exit(1);
  }
  
  /* we use the -I option to feed in the configuration,
   * and we put ours in front of eventually existing options
   */
  if (commandline_statements) {
    cbuf = malloc(csize+1+strlen(commandline_statements)+1);
    read(fd, cbuf, csize);
    cbuf[csize] = '\n';
    strcpy(cbuf+csize+1, commandline_statements);
  }
  else {
    cbuf = malloc(csize+1);
    read(fd, cbuf, csize);
    cbuf[csize] = 0;
  }
  commandline_statements = cbuf;
  close(fd);

  start_disk();
  dptr->type = IMAGE;
  dptr->header = HEADER_SIZE;
  dptr->dev_name = n;
  dptr->dexeflags = ihdr.dexeflags | DISK_IS_DEXE;
  stop_disk(DISK);
  dexe_running = 1;
}


static void do_parse(FILE* fp, char *confname, char *errtx)
{
        yyin = fp;
        line_count = 1;
	include_stack_ptr = 0;
        c_printf("CONF: Parsing %s file.\n", confname);
	file_being_parsed = strdup(confname);
	include_fnames[include_stack_ptr] = file_being_parsed;
	yyrestart(fp);
        if (yyparse()) yyerror(errtx, confname);
        close_file(fp);
	include_stack_ptr = 0;
	include_fnames[include_stack_ptr] = 0;
	free(file_being_parsed);
}

int parse_config(char *confname, char *dosrcname)
{
  FILE *fd;
  int is_user_config;
#if YYDEBUG != 0
  yydebug  = 1;
#endif

  define_config_variable(PARSER_VERSION_STRING);

  /* Let's try confname if not null, and fail if not found */
  /* Else try the user's own .dosrc (old) or .dosemurc (new) */
  /* If that doesn't exist we will default to CONFIG_FILE */

  { 
    if (!dosrcname) {
      char *name = get_path_in_HOME(DOSEMU_RC);
      setenv("DOSEMU_RC", name, 1);
      free(name);
    }
    else {
      setenv("DOSEMU_RC",dosrcname,1);
    }

    /* privileged options allowed? */
    is_user_config = (confname && config_script_path && strcmp(confname, config_script_path));
    priv_lvl = !under_root_login && can_do_root_stuff && is_user_config;

    /* DEXE together with option F ? */
    if (priv_lvl && dexe_running) {
      /* for security reasons we cannot allow this */
      fprintf(stderr, "user cannot load DEXE file together with option -F\n");
      exit(1);
    }

    if (is_user_config) define_config_variable("c_user");
    else define_config_variable("c_system");
    if (dexe_running) define_config_variable("c_dexerun");

    yy_vbuffer = dosemu_conf;
    do_parse(NULL, "built-in dosemu.conf", "error in built-in dosemu.conf");
    yy_vbuffer = global_conf;
    do_parse(NULL, "built-in global.conf", "error in built-in global.conf");
    if (confname) {
      yy_vbuffer = NULL;
      fd = open_file(confname);
      if (!fd) {
        if (!dexe_running) {
          fprintf(stderr, "Cannot open base config file %s, Aborting DOSEMU.\n",confname);
          exit(1);
        }
      }
      do_parse(fd, confname, "error in configuration file %s");
    }

    if (priv_lvl) undefine_config_variable("c_user");
    else undefine_config_variable("c_system");

    if (!get_config_variable(CONFNAME_V3USED)) {
	/* we obviously have an old configuration file
         * ( or a too simple one )
	 * giving up
	 */
	yyerror("\nYour %s script or configuration file is obviously\n"
		"an old style or a too simple one\n"
		"Please read README.txt on how to upgrade\n", confname);
	exit(1);
    }

    /* privileged options allowed for user's config? */
    priv_lvl = !under_root_login && can_do_root_stuff;
    if (priv_lvl) define_config_variable("c_user");

    /* Now we parse any commandline statements from option '-I'
     * We do this under priv_lvl set above, so we have the same secure level
     * as with .dosrc
     */

    if (commandline_statements) {
      #define XX_NAME "commandline"

      open_file(0);
      define_config_variable("c_comline");
      c_printf("Parsing " XX_NAME  " statements.\n");
      yyin=0;				 /* say: we have no input file */
      yy_vbuffer=commandline_statements; /* this is the input to scan */
      do_parse(0, XX_NAME, "error in user's %s statement");
      undefine_config_variable("c_comline");
    }
  }

  /* check for global settings, that should know the whole settings
   * This we only can do, after having parsed all statements
   */

  if (dexe_running) {
    /* force a BootC,
     * regardless what ever was set in the config files
     */
    config.hdiskboot = 1;
  }
  else {
    if (get_config_variable("c_dexeonly")) {
       c_printf("CONF: only execution of DEXE files allowed\n");
       fprintf(stderr, "only execution of DEXE files allowed\n");
       exit(99);
    }
  }

#ifdef TESTING
  error("TESTING: parser is terminating program\n");
  exit(0);
#endif
  return 1;
}

#define MAX_CONFIGVARIABLES 128
char *config_variables[MAX_CONFIGVARIABLES+1] = {0};
static int config_variables_count = 0;
static int config_variables_last = 0;
static int allowed_classes = -1;
static int saved_allowed_classes = -1;



static int is_in_allowed_classes(int mask)
{
  if (!(allowed_classes & mask)) {
    yyerror("insufficient class privilege to use this configuration option\n");
    exit(99);
  }
  return 1;
}

struct config_classes {
	char *class;
	int mask;
} config_classes[] = {
	{"c_all", CL_ALL},
	{"c_normal", CL_ALL & (~(CL_VAR | CL_VPORT | CL_IRQ | CL_HARDRAM | CL_PCI | CL_NET))},
	{"c_var", CL_VAR},
	{"c_system", CL_ALL},
	{"c_vport", CL_VPORT},
	{"c_port", CL_PORT},
	{"c_irq", CL_IRQ},
	{"c_pci", CL_PCI},
	{"c_hardram", CL_HARDRAM},
	{"c_net", CL_NET},
	{0,0}
};

static int get_class_mask(char *name)
{
  struct config_classes *p = &config_classes[0];
  while (p->class) {
    if (!strcmp(p->class,name)) return p->mask;
    p++;
  }
  return 0;
}

static void update_class_mask(void)
{
  int i, m;
  allowed_classes = 0;
  for (i=0; i< config_variables_count; i++) {
    if ((m=get_class_mask(config_variables[i])) != 0) {
      allowed_classes |= m;
    }
  }
}

static void enter_user_scope(int incstackptr)
{
  if (user_scope_level) return;
  saved_priv_lvl = priv_lvl;
  priv_lvl = 1;
  saved_allowed_classes = allowed_classes;
  allowed_classes = 0;
  user_scope_level = incstackptr;
  c_printf("CONF: entered user scope, includelevel %d\n", incstackptr-1);
}

static void leave_user_scope(int incstackptr)
{
  if (user_scope_level != incstackptr) return;
  priv_lvl = saved_priv_lvl;
  allowed_classes = saved_allowed_classes;
  user_scope_level = 0;
  c_printf("CONF: left user scope, includelevel %d\n", incstackptr-1);
}

char *get_config_variable(char *name)
{
  int i;
  for (i=0; i< config_variables_count; i++) {
    if (!strcmp(name, config_variables[i])) {
      config_variables_last = i;
      return config_variables[i];
    }
  }
  return 0;
}

int define_config_variable(char *name)
{
  if (priv_lvl) {
    if (strcmp(name, CONFNAME_V3USED) && strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to define config variable %s\n", name);
      return 0;
    }
  }
  if (!get_config_variable(name)) {
    if (config_variables_count < MAX_CONFIGVARIABLES) {
      config_variables[config_variables_count++] = strdup(name);
      if (!priv_lvl) update_class_mask();
    }
    else {
      if (after_secure_check)
        c_printf("CONF: overflow on config variable list\n");
      return 0;
    }
  }
  if (after_secure_check)
    c_printf("CONF: config variable %s set\n", name);
  return 1;
}

static int undefine_config_variable(char *name)
{
  if (priv_lvl) {
    if (strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to undefine config variable %s\n", name);
      return 0;
    }
  }
  if (get_config_variable(name)) {
    int i;
    if (!strcmp(name, CONFNAME_V3USED)) parser_version_3_style_used = 0;
    free(config_variables[config_variables_last]);
    for (i=config_variables_last; i<(config_variables_count-1); i++) {
      config_variables[i] = config_variables[i+1];
    }
    config_variables_count--;
    if (!priv_lvl) update_class_mask();
    c_printf("CONF: config variable %s unset\n", name);
    return 1;
  }
  return 0;
}

char *checked_getenv(const char *name)
{
  if (user_scope_level) {
     char *s, *name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
     strcpy(name_, USERVAR_PREF);
     strcat(name_, name);
     s = getenv(name_);
     free(name_);
     if (s) return s;
  }
  return getenv(name);
}

static void check_user_var(char *name)
{
	char *name_;
	char *s;

	if (user_scope_level) return;
	name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
	strcpy(name_, USERVAR_PREF);
	strcat(name_, name);
	s = getenv(name_);
	if (s) {
		if (getenv(name))
			c_printf("CONF: variable %s replaced by user\n", name);
		setenv(name, s, 1);
		unsetenv(name_);
	}
	free(name_);
}


static char *run_shell(char *command)
{
	int pipefds[2];
	pid_t pid;
	char excode[16] = "1";

	setenv("DOSEMU_SHELL_RETURN", excode, 1);
	if (pipe(pipefds)) return strdup("");
	pid = fork();
	if (pid == -1) return strdup("");
	if (!pid) {
		/* child */
		int ret;
		close(pipefds[0]);	/* we won't read from the pipe */
		dup2(pipefds[1], 1);	/* make the pipe child's stdout */
		priv_drop();	/* drop any priviledges */
		ret = system(command);
			/* tell the parent: "we have finished",
			 * this way we need not to play games with select()
			 */
		if (ret == -1) ret = errno;
		else ret >>=8;
		write(pipefds[1],"\0\0\0",4);
		close(pipefds[1]);
		_exit(ret);
	}
	else {
		/* parent */
		char *buf = 0;
		int recsize = 128;
		int bufsize = 0;
		int ptr =0;
		int ret;
		int status;

		close(pipefds[1]);	/* we won't write to the pipe */
		do {
			bufsize = ptr + recsize;
			if (!buf) buf = malloc(bufsize);
			else buf = realloc(buf, bufsize);
			ret = read(pipefds[0], buf+ptr, recsize -1);
			if (ret > 0) {
				ptr += ret;
			}
		} while (ret >0 && (ret < 4 || memcmp(buf+ptr-4,"\0\0\0",4)));
		close(pipefds[0]);
		waitpid(pid, &status, 0);
		buf[ptr] = 0;
		if (!buf[0]) {
			free(buf);
			buf = strdup("");
		}
		sprintf(excode, "%d", WEXITSTATUS(status));
		setenv("DOSEMU_SHELL_RETURN", excode, 1);
		return buf;
	}
}


struct for_each_entry {
	char *list;
	char *ptr;
	int skip_restart;
};

#define FOR_EACH_DEPTH	16
static struct for_each_entry *for_each_list = 0;

static int for_each_handling(int loopid, char *varname, char *delim, char *list)
{
	struct for_each_entry *fe;
	char * new;
	char saved;
	if (!for_each_list) {
		int size = FOR_EACH_DEPTH * sizeof(struct for_each_entry);
		for_each_list = malloc(size);
		memset(for_each_list, 0, size);
	}
	if (loopid > FOR_EACH_DEPTH) {
		yyerror("too deeply nested foreach\n");
		return 0;
	}
	fe = for_each_list + loopid;
	if (!fe->list) {
		/* starting the loop */
		fe->ptr = fe->list = strdup(list);
		fe->skip_restart = 0;
		if (loopid) {
			/* in inner loops we need to skip the restart */
			fe->skip_restart = 1;
		}
	}
	else {
		if (fe->skip_restart) {
			fe->skip_restart = 0;
			return 1;
		}
	}
	while (fe->ptr[0] && strchr(delim,fe->ptr[0])) fe->ptr++;
	/* subsequent call */
	if (!fe->ptr[0]) {
		/* loop end */
		free(fe->list);
		fe->list = 0;
		return (0);
	}
	new = strpbrk(fe->ptr, delim);
	if (!new) new = strchr(fe->ptr,0);
	saved = *new;
	*new = 0;
	setenv(varname,fe->ptr,1);
	if (saved) new++;
	fe->ptr = new;
	return (1);
}

#ifdef TESTING_MAIN

static void die(char *reason)
{
  error("par dead: %s\n", reason);
  exit(0);
}

int
main(int argc, char **argv)
{
  if (argc != 2)
    die("no filename!");

  if (!parse_config(argv[1], argv[2] /* will be NULL if not given */))
    die("parse failed!\n");
}

#endif

/* for keyboard plugin */



static void keyb_mod(int wich, t_keysym keynum, int unicode)
{
	static t_keysym *table = 0;
	static int count = 0;
	
	if (wich == ' ') {
		switch (keynum & 0xFF00) {
		case 0x000: wich = ' '; break;
		case 0x100: wich = 'S'; break;
		case 0x200: wich = 'A'; break;
		case 0x300: wich = 'N'; break;
		case 0x400: wich = 'C'; break;
		case 0x500: wich = 'a'; break;
		case 0x600: wich = 'c'; break;
		default: 
			/* It's a bad value ditch it */
			wich ='X'; table = 0; count = 0; break;
		}
		keynum &= 0xFF;
	}

	switch (wich) {
	case ' ': table = config.keytable->key_map;
		count=config.keytable->sizemap;
		break;
	case 'S': table = config.keytable->shift_map;
		count=config.keytable->sizemap;
		break;
	case 'A': table = config.keytable->alt_map;
		count=config.keytable->sizemap;
		break;
	case 'C': table = config.keytable->ctrl_map;
		count=config.keytable->sizemap;
		break;
	case 'a': table = config.keytable->shift_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'c': table = config.keytable->ctrl_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'N': table = config.keytable->num_table;
		count=config.keytable->sizepad;
		break;
	}


	if (!table || (count == 0) || (wich != 0 && keynum >= count)) {
		count = 0;
		table = 0;
		return;
	}
	if (wich != 0) {
		table += keynum;
		count -= keynum;
		return;
	}
	if (!unicode) {
		if (keynum == 0) {
			keynum = KEY_VOID;
		} else {
			keynum = keynum + 0xEF00;
		}
	}
	if (count > 0) {
		*table++ = keynum;
		count--;
	}
}


static char *get_key_name(t_keysym key)
{
	struct key_names {
		t_keysym key;
		char *name;
	};
	static struct key_names names[] =
	{
		{ KEY_DEAD_GRAVE,	"dgrave"},
		{ KEY_DEAD_ACUTE,	"dacute"},
		{ KEY_DEAD_CIRCUMFLEX,	"dcircum"},
		{ KEY_DEAD_TILDE,	"dtilde"},
		{ KEY_DEAD_BREVE,	"dbreve"},
		{ KEY_DEAD_ABOVEDOT,	"daboved"},
		{ KEY_DEAD_DIAERESIS,	"ddiares"},
		{ KEY_DEAD_ABOVERING,	"dabover"},
		{ KEY_DEAD_DOUBLEACUTE,	"ddacute"},
		{ KEY_DEAD_CEDILLA,	"dcedilla"},
		{ KEY_DEAD_OGONEK,	"dogonek"},
		{ KEY_DEAD_CARON,	"dcaron"},
	};
	int i;
	for(i = 0; i < sizeof(names)/sizeof(names[0]); i++) {
		if (names[i].key == key) {
			return names[i].name;
		}
	}
	return 0;
}

static void dump_keytable_part(FILE *f, t_keysym *map, int size)
{
  int i, in_string=0;
  t_keysym c;
  unsigned char *cc, comma=' ', buf[16];

  /* Note: This code assumes every font is a superset of ascii */
  if (!map) {
	  return;
  }
  size--;
  for (i=0; i<=size; i++) {
    c = map[i];
    if (!(i & 15)) fprintf(f,"    ");
    cc = get_key_name(c);
    if (!cc && (c < 128) && isprint(c) && !strchr("\\\"\'`", c)) {
      if (in_string) fputc(c,f);
      else {
        fprintf(f, "%c\"%c", comma, c);
        in_string = 1;
      }
    }
    else {
      if (!cc) {
	if (((c > 0) && (c < 128)) || ((c >= 0xEF00) && (c <= 0xEFFF))) {
	  sprintf(buf, "%d", c & 0xFF);
	} else if (c == KEY_VOID) {
	  strcpy(buf, "0");
	} else {
	  sprintf(buf, "\\u%04x", c);
	}
	cc = buf;
      }
      if (!in_string) fprintf(f, "%c%s", comma, cc);
      else {
        fprintf(f, "\",%s", cc);
        in_string = 0;
      }
    }
    if ((i & 15) == 15) {
      if (in_string) fputc('"', f);
      if (i < size) fputc(',', f);
      fputc('\n', f);
      in_string = 0;
      comma = ' ';
    }
    else comma = ',';
  }
  if (in_string) fputc('"', f);
  fputc('\n', f);
}


void dump_keytable(FILE *f, struct keytable_entry *kt)
{
    fprintf(f, "keytable %s {\n", kt->name);
    fprintf(f, "  0=\n");
    dump_keytable_part(f, kt->key_map, kt->sizemap);
    fprintf(f, "  shift 0=\n");
    dump_keytable_part(f, kt->shift_map, kt->sizemap);
    fprintf(f, "  alt 0=\n");
    dump_keytable_part(f, kt->alt_map, kt->sizemap);
    fprintf(f, "  numpad 0=\n");
    dump_keytable_part(f, kt->num_table, kt->sizepad-1);
    fprintf(f, "  ctrl 0=\n");
    dump_keytable_part(f, kt->ctrl_map, kt->sizemap);
    fprintf(f, "  shift-alt 0=\n");
    dump_keytable_part(f, kt->shift_alt_map, kt->sizemap);
    fprintf(f, "  ctrl-alt 0=\n");
    dump_keytable_part(f, kt->ctrl_alt_map, kt->sizemap);
    fprintf(f, "}\n\n\n");
}



	/* charset */
static struct char_set *get_charset(char *name)
{
	struct char_set *charset;

	charset = lookup_charset(name);
	if (!charset) {
		yyerror("Can't find charset %s", name);
	}
	return charset;

}

static void set_external_charset(char *charset_name)
{
	struct char_set *charset;
	charset = get_charset(charset_name);
	charset = get_terminal_charset(charset);
	if (charset) {
		if (!trconfig.output_charset) {
			trconfig.output_charset = charset;
		}
		if (!trconfig.keyb_charset) {
			trconfig.keyb_charset = charset;
		}
	}
	return;
}

static void set_internal_charset(char *charset_name)
{
	struct char_set *charset_video, *charset_config;
	charset_video = get_charset(charset_name);
	if (!is_display_charset(charset_video)) {
		yyerror("%s not suitable as an internal charset", charset_name);
	}
	charset_config = get_terminal_charset(charset_video);
	if (charset_video && !trconfig.video_mem_charset) {
		trconfig.video_mem_charset = charset_video;
	}
	if (charset_config && !trconfig.keyb_config_charset) {
		trconfig.keyb_config_charset = charset_config;
	}
	if (charset_config && !trconfig.dos_charset) {
		trconfig.dos_charset = charset_config;
	}
	return;
}


